package no.oslotuc.net.urls;

import java.util.regex.Pattern;

public class UrlPattern {

    private Class cls;
    private String methodName;
    private Pattern urlPattern;



    public UrlPattern(Class cls, String methodName, Pattern urlPattern) {

        this.cls = cls;
        this.methodName = methodName;
        this.urlPattern = urlPattern;

    }

    public Class getCls() {
        return cls;
    }

    public String getMethodName() {
        return methodName;
    }

    public Pattern getUrlPattern() {
        return urlPattern;
    }

    @Override
    public boolean equals(Object object) {

        if(!(object instanceof UrlPattern)) {
            return false;
        }

        UrlPattern urlPattern = (UrlPattern)object;

        if(urlPattern.urlPattern.pattern().equals(this.urlPattern.pattern()))
            return true;
        return false;
    }
}
