$(function() {

    $('#waiting').hide();

    $('textarea#query').textntags({
        triggers: {'#': {
            uniqueTags   : false,
            minChars: 1
        }},
        onDataRequest:function (mode, query, triggerChar, callback) {
            /* Should ideally come from the server */
            var data = {
                '#': [{"name":"Rådhussvingen"},{"name":"Ski skole"},{"name":"Ski stasjon"},{"name":"Furuveien"},{"name":"Langhus stasjon"},{"name":"Ødegårdsvegen"},{"name":"Langhus senter"},{"name":"Vevelstad stasjon"},{"name":"Stenfelt"},{"name":"Gamle Vevelstadveg"},{"name":"Mastemyr hotell"},{"name":"Lienga"},{"name":"Mastemyr"},{"name":"Trollåsen"},{"name":"Sagveien"},{"name":"Oppegård næringspark"},{"name":"Gjersjøen"},{"name":"Ingierodden"},{"name":"Ingierkollveien"},{"name":"Oppegård Rådhus"},{"name":"Oppegård rådhus"},{"name":"Mellomveien"},{"name":"Skogveien"},{"name":"IBM"},{"name":"Trollåsveien"},{"name":"Kolbotn stasjon"},{"name":"Kolbotn sentrum"},{"name":"Kolbotnkrysset"},{"name":"Nordberg"},{"name":"Nordberg"},{"name":"Frøyas vei"},{"name":"Landerudsenteret"},{"name":"Ødegården"},{"name":"Jotunveien"},{"name":"Gautes vei"},{"name":"Huldrefaret"},{"name":"Tårnlia"},{"name":"Tårnåsen"},{"name":"Høyås"},{"name":"Solbråtan stasjon"},{"name":"HV-huset"},{"name":"Sofiemyr"},{"name":"Granholtet"},{"name":"Taraldrudveien"},{"name":"Idrettsparken"},{"name":"Rognebærlia"},{"name":"Blåbærskogen"},{"name":"Østli"},{"name":"Myrvoll stasjon"},{"name":"Greverud kirke"},{"name":"Greverud stasjon"},{"name":"Greverud skole"},{"name":"Oppegård stasjon"},{"name":"Rosenholm stasjon"},{"name":"Grini"},{"name":"Grini"},{"name":"Nordjordet"},{"name":"Eiksmarka"},{"name":"Niels Leuchs vei"},{"name":"Rideveien"},{"name":"Ovenbakken"},{"name":"Lijordet"},{"name":"Østerås T"},{"name":"Lysaker stasjon"},{"name":"Lysaker brygge"},{"name":"Postterminalen"},{"name":"Georg Stangs vei"},{"name":"Snorres vei"},{"name":"Lørenskog sentrum"},{"name":"Akershus sykehus"},{"name":"Visperud"},{"name":"Lørenskog stasjon"},{"name":"Bjørvika"},{"name":"Jernbanetorget T"},{"name":"Jernbanetorget T"},{"name":"Jernbanetorget"},{"name":"Dronningens gate"},{"name":"Børsen"},{"name":"Vestbanen"},{"name":"Dokkveien"},{"name":"Stortorvet"},{"name":"Prof. Aschehougs plass"},{"name":"Tullinløkka"},{"name":"Holbergs plass"},{"name":"Brugata"},{"name":"Rådhuset"},{"name":"Arne Garborgs plass"},{"name":"Bryggetorget"},{"name":"Vika Atrium"},{"name":"Solli"},{"name":"Skovveien"},{"name":"Lapsetorvet"},{"name":"Niels Juels gate"},{"name":"Observatoriegata"},{"name":"Elisenberg"},{"name":"Frogner kirke"},{"name":"Odins gate"},{"name":"Lille Frogner allé"},{"name":"Olav Kyrres plass"},{"name":"Karenslyst allé"},{"name":"Frognerkilen"},{"name":"Kongsgården"},{"name":"Huk"},{"name":"Ro"},{"name":"Frimurerhjemmet"},{"name":"Bygdøhus"},{"name":"Fredriksborg"},{"name":"Vikingskipene"},{"name":"Folkemuseet"},{"name":"Majorstuen"},{"name":"Majorstuen"},{"name":"Welhavens gate"},{"name":"Homansbyen"},{"name":"Homansbyen"},{"name":"Bogstadveien"},{"name":"Frogner plass"},{"name":"Vigelandsparken"},{"name":"Frogner stadion"},{"name":"Uranienborgveien"},{"name":"Riddervolds plass"},{"name":"Dalsbergstien"},{"name":"Frydenlund"},{"name":"Bislett"},{"name":"Bislett"},{"name":"Stensgata"},{"name":"Adamstuen"},{"name":"Sofies plass"},{"name":"St. Hanshaugen"},{"name":"St. Hanshaugen"},{"name":"Stensberggata"},{"name":"Nordahl Bruns gate"},{"name":"Colletts gate"},{"name":"Alex. Kiellands plass"},{"name":"Telthusbakken"},{"name":"Falck Ytters plass"},{"name":"Evald Ryghs gate"},{"name":"Lovisenberg"},{"name":"Tannlegehøyskolen"},{"name":"Ullevål sykehus"},{"name":"Ullevål sykehus"},{"name":"Vestre Aker kirke"},{"name":"Vestre Aker kirke"},{"name":"Marienlyst"},{"name":"Lindern"},{"name":"Fayes gate"},{"name":"John Colletts plass"},{"name":"Ullevålsalléen"},{"name":"Eventyrveien"},{"name":"Domus Athletica"},{"name":"Arkitekt Rivertz plass"},{"name":"Sagene"},{"name":"Sagene"},{"name":"Voldsløkka"},{"name":"Bjølsen"},{"name":"Advokat Dehlis plass"},{"name":"Arendalsgata"},{"name":"Badebakken"},{"name":"Kristoffer Aamots bro"},{"name":"Torshov"},{"name":"Lilleborg kirke"},{"name":"Torshovparken"},{"name":"Sandaker senter"},{"name":"Grefsenveien"},{"name":"Kristoffer Aamots gate"},{"name":"Hausmanns gate"},{"name":"Nybrua"},{"name":"Schous plass"},{"name":"Olaf Ryes plass"},{"name":"Calmeyers gate"},{"name":"Jakob kirke"},{"name":"Møllerveien"},{"name":"Birkelunden"},{"name":"Sannergata"},{"name":"Københavngata"},{"name":"Biermanns gate"},{"name":"Helgesens gate"},{"name":"Tøyen"},{"name":"Tøyen skole"},{"name":"Munchmuseet"},{"name":"Tøyengata"},{"name":"Norbygata"},{"name":"Tøyenkirken"},{"name":"Bussterminalen Grønland"},{"name":"Bussterminalen Grønland"},{"name":"St. Halvards plass"},{"name":"Ladegården"},{"name":"Dyvekes bro"},{"name":"Oslo gate"},{"name":"Munkegata"},{"name":"Politihuset"},{"name":"Harald Hårdrådes plass"},{"name":"Galgeberg"},{"name":"Galgeberg"},{"name":"Vålerenga"},{"name":"Etterstadgata"},{"name":"Kjølberggata"},{"name":"Kværner"},{"name":"Lodalen"},{"name":"Eirik Raudes vei"},{"name":"Kongshavn"},{"name":"Ekeberghallen"},{"name":"Ekeberg Camping"},{"name":"Brannfjellveien"},{"name":"Utsikten"},{"name":"Simensbrekka"},{"name":"Ryenbergveien"},{"name":"Bekkelagsveien"},{"name":"Nedre Bekkelaget"},{"name":"Nedre Bekkelaget"},{"name":"Ulvøybrua"},{"name":"Ulvøya"},{"name":"Holtet"},{"name":"Holtet stasjon"},{"name":"Bekkelagshjemmet"},{"name":"Malmøya"},{"name":"Malmøysundet"},{"name":"Kirkebakken"},{"name":"Mailand"},{"name":"Ormsundbakken"},{"name":"Simensbråten"},{"name":"Ekeberg hageby"},{"name":"Brattlikollen T"},{"name":"Nordstrand bad"},{"name":"Vølund"},{"name":"Katten"},{"name":"Ljansbakken"},{"name":"Gladvollveien"},{"name":"Fiskevollen"},{"name":"Siksakveien"},{"name":"Sørli"},{"name":"Kastellet"},{"name":"Skovheim"},{"name":"Bråten"},{"name":"Sæter"},{"name":"Munkerud"},{"name":"P. A. Holms vei"},{"name":"Sæter"},{"name":"Ljabru"},{"name":"Knud Øyens vei"},{"name":"Nordstrand kirke"},{"name":"Ingiers vei"},{"name":"Kronveien"},{"name":"Maikollen"},{"name":"Granebakken"},{"name":"Olasrudveien"},{"name":"Hauketo stasjon"},{"name":"Asperudveien"},{"name":"Sveavegen"},{"name":"Lerdal"},{"name":"Ljabru hovedgård"},{"name":"Nebbejordet"},{"name":"Asperudåsen"},{"name":"Asperudtoppen"},{"name":"Lerdalstoppen"},{"name":"Holmlia stasjon"},{"name":"Skovbakken syd"},{"name":"Ravnkroken"},{"name":"Ravnåsen"},{"name":"Sloreåsen"},{"name":"Skovbakken nord"},{"name":"Hallagerbakken"},{"name":"Krummedike"},{"name":"Nordåsveien"},{"name":"Rosenholmveien"},{"name":"Åstun"},{"name":"Vestskrenten"},{"name":"Grensestien"},{"name":"Åsbråten"},{"name":"Prinsdal"},{"name":"Prinsdalsbakken"},{"name":"Trygve Strømbergs vei"},{"name":"Berglyveien"},{"name":"Høgåsveien"},{"name":"Toppåsveien"},{"name":"Nordbråtan"},{"name":"Liakollen"},{"name":"Mortensrud T"},{"name":"Gamle bygdevei"},{"name":"Lofsrudhøgda"},{"name":"Brunas vei"},{"name":"Blakkens vei"},{"name":"Oredalen"},{"name":"Bjørnerud"},{"name":"Mortensrudkrysset"},{"name":"Mortensrudkrysset"},{"name":"Dalsåsen"},{"name":"Stenbråten"},{"name":"Kantarellen legesenter"},{"name":"Kantarellen terrasse"},{"name":"Kantarellen"},{"name":"Tangen"},{"name":"Bjørnholt nedre"},{"name":"Bjørnholt øvre"},{"name":"Nyjordet"},{"name":"Bjørndal senter"},{"name":"Meklenborg"},{"name":"Bjørndal"},{"name":"Langteigåsen"},{"name":"Bjørnholt skole"},{"name":"Søndre Dal"},{"name":"Nordre Dal"},{"name":"Lille Dal"},{"name":"Dalssvingen"},{"name":"Dalsroa"},{"name":"Brenna"},{"name":"Bratli"},{"name":"Pasop"},{"name":"Karlsrud T"},{"name":"Lambertseter senter"},{"name":"Gina Krogs vei"},{"name":"Munkelia T"},{"name":"Langbølgen"},{"name":"Bergkrystallen T"},{"name":"Blåfjellet"},{"name":"Vilbergveien"},{"name":"Østmarkveien"},{"name":"Olav Nygards veg"},{"name":"Bøler T"},{"name":"Martin Linges vei"},{"name":"Bogerud T"},{"name":"Welding Olsens vei"},{"name":"Skullerudveien"},{"name":"Skullerud T"},{"name":"Johan Scharffenbergs vei"},{"name":"Langerud sykehjem"},{"name":"Paal Bergs vei"},{"name":"Skullerudbakken"},{"name":"Skullerudkrysset"},{"name":"Ryen T"},{"name":"Ryen T"},{"name":"Ryen"},{"name":"Ryenberget"},{"name":"Ryensvingen"},{"name":"Sandstuveien"},{"name":"Manglerud T"},{"name":"Manglerudveien"},{"name":"Furuveien"},{"name":"Høyenhall T"},{"name":"Bryn senter"},{"name":"Rognerud"},{"name":"Abildsø"},{"name":"Smedberg"},{"name":"Alléen"},{"name":"Lille Langerud"},{"name":"Langerudveien"},{"name":"Skøyenåsen T"},{"name":"Skøyenkroken"},{"name":"Østensjø skole"},{"name":"Oppsal senter"},{"name":"Solbergliveien"},{"name":"Kampheimveien"},{"name":"Eftasåsen"},{"name":"Carl Berners plass"},{"name":"Hasle"},{"name":"Hasle"},{"name":"Haslevangen"},{"name":"Einars vei"},{"name":"Fougners vei"},{"name":"Carl Berners plass T"},{"name":"Tøyen stasjon"},{"name":"Ensjøveien"},{"name":"Hasle kirke"},{"name":"St. Jørgens vei"},{"name":"Lillebergsvingen"},{"name":"Valle"},{"name":"Grensesvingen"},{"name":"Fyrstikktorget"},{"name":"Helsfyr T"},{"name":"Helsfyr"},{"name":"Etterstad skole"},{"name":"Etterstad vest"},{"name":"Etterstad sør"},{"name":"Etterstadkroken"},{"name":"Brynseng T"},{"name":"Bryn brannstasjon"},{"name":"Teisenkrysset"},{"name":"Teisenkrysset"},{"name":"Tveten bru"},{"name":"Klosterheim"},{"name":"Bryn skole"},{"name":"Prost Hallings vei"},{"name":"Ulvenkrysset"},{"name":"Fjellhus"},{"name":"Ole Deviks vei"},{"name":"Caspar Storms vei"},{"name":"Fretex"},{"name":"Hellerud"},{"name":"Tveten gård"},{"name":"Tveita"},{"name":"Tveita"},{"name":"Tveita bedriftsområde"},{"name":"Stordamveien"},{"name":"Haugerud T"},{"name":"Haugerudveien"},{"name":"Doktor Dedichens vei"},{"name":"Trasop skole"},{"name":"Hellerudfaret"},{"name":"Trasoppveien"},{"name":"Alfaset"},{"name":"Alna senter"},{"name":"Smalvollveien"},{"name":"Knud Bryns vei"},{"name":"Arvesetveien"},{"name":"Postens verksteder"},{"name":"Nordre Hovin"},{"name":"Tollpost-Globe"},{"name":"Postens godssenter"},{"name":"Lindeberg T"},{"name":"Lindeberg sykehjem"},{"name":"Jeriko skole"},{"name":"Furuset skole"},{"name":"Furuset skole"},{"name":"Furuset T"},{"name":"Nordre Gran"},{"name":"Gransletta"},{"name":"Vestre Haugen"},{"name":"Stjerneblokkveien"},{"name":"Ellingsrudåsen T"},{"name":"Edvard Munchs vei"},{"name":"Karihaugen"},{"name":"IKEA Furuset"},{"name":"Alnaparkveien"},{"name":"Prof. Birkelands vei"},{"name":"Skjønhaug"},{"name":"Trosterudkrysset"},{"name":"Trosterudkrysset"},{"name":"Kjelsrud"},{"name":"Kjelsrud"},{"name":"Alfaset gravlund"},{"name":"Alfasetveien"},{"name":"Folkvangveien"},{"name":"Stovner T"},{"name":"Fossum"},{"name":"Vestli T"},{"name":"Gullberget"},{"name":"Jacobine Ryes vei"},{"name":"Haugenstua torg"},{"name":"Haavard Martinsens vei"},{"name":"Jernkroken"},{"name":"Smedstua"},{"name":"Haugenstua skole"},{"name":"Rødtvet"},{"name":"Rødtvet"},{"name":"Kalbakkveien"},{"name":"Kalbakkstubben"},{"name":"Sagstuveien"},{"name":"Grorud skole"},{"name":"Grorud T"},{"name":"Bredtvet"},{"name":"Tine"},{"name":"Lindab"},{"name":"Christoffer Hellums vei"},{"name":"Nedre Kalbakkvei"},{"name":"Nyland stasjon"},{"name":"Stanseveien"},{"name":"Stålfjæra"},{"name":"Falch-gården"},{"name":"Stanseveien"},{"name":"Grorud stasjon"},{"name":"Grorud stasjon"},{"name":"Bekkenstenveien"},{"name":"Nordlisvingen"},{"name":"Grorudveien"},{"name":"Vestbyveien"},{"name":"Vestbyveien"},{"name":"Økern T"},{"name":"Risløkkalléen"},{"name":"Siemens"},{"name":"Vollebekk"},{"name":"Veitvetveien"},{"name":"Veitvet"},{"name":"Linderudsletta"},{"name":"Linderudsletta"},{"name":"Linderud senter"},{"name":"Øvre Lunden"},{"name":"Kolåsbakken"},{"name":"Haraldrudveien"},{"name":"Persveien"},{"name":"Bjerke"},{"name":"Bjerke"},{"name":"Brobekk"},{"name":"Årvoll senter"},{"name":"Årvollveien"},{"name":"Tonsenhagen"},{"name":"Tonsenhagen torg"},{"name":"Stig"},{"name":"Lofthus"},{"name":"Årrundveien"},{"name":"Sinsenveien"},{"name":"Lørenvangen"},{"name":"Sinsenkrysset"},{"name":"Grefsen stasjon"},{"name":"Storo"},{"name":"Storo"},{"name":"Nydalen stasjon"},{"name":"Lillo terrasse"},{"name":"Nydalen T"},{"name":"Disen"},{"name":"Doktor Smiths vei"},{"name":"Glads vei"},{"name":"Grefsenplatået"},{"name":"Grefsenkollveien"},{"name":"Kjelsås stasjon"},{"name":"Kjelsåsalléen"},{"name":"Grefsen stadion"},{"name":"Lyngåsveien"},{"name":"Brannvaktveien"},{"name":"Grefsenlia"},{"name":"Frysja"},{"name":"Stillatorvet"},{"name":"Brekke"},{"name":"Ullevål stadion"},{"name":"Ullevål stadion"},{"name":"Yrkesskolen"},{"name":"Solvang"},{"name":"Christophers vei"},{"name":"Østhellinga"},{"name":"Tåsen allé"},{"name":"Tåsen senter"},{"name":"Øvre Stabburvei"},{"name":"Nygård"},{"name":"Blåsbortveien"},{"name":"Godals vei"},{"name":"Nydalsveien"},{"name":"Havnabakken"},{"name":"Korsvollbråtan"},{"name":"Nordberghjemmet"},{"name":"Kongleveien"},{"name":"Nordbergveien"},{"name":"Kringsjå"},{"name":"Kringsjå"},{"name":"Skibakken"},{"name":"Korsvollbakken"},{"name":"Korsvoll"},{"name":"Brekkehagan"},{"name":"Brekkekrysset"},{"name":"Svensenga"},{"name":"Frøensalléen"},{"name":"Steinerud T"},{"name":"Vinderen T"},{"name":"Gaustad T"},{"name":"Ris T"},{"name":"Slemdal T"},{"name":"Svenstua"},{"name":"Lybekkveien"},{"name":"Krags vei"},{"name":"Midtstuen"},{"name":"Besserud T"},{"name":"Makrellbekken"},{"name":"Arnebråtveien"},{"name":"Amagerveien"},{"name":"Huseby skole"},{"name":"Hovseter T"},{"name":"Hovseter skole"},{"name":"Hovseterhjemmet"},{"name":"Orebakken"},{"name":"Ostadalsveien"},{"name":"Aslakveien"},{"name":"Røa næringspark"},{"name":"Ullerntoppen"},{"name":"Røa T"},{"name":"Kristian Auberts vei"},{"name":"Røa kirke"},{"name":"Ekraveien"},{"name":"Linhusveien"},{"name":"Vennerstua"},{"name":"Himstadplassen"},{"name":"Bogstad Camping"},{"name":"Voksen skog"},{"name":"Grindbakken"},{"name":"Åsly"},{"name":"Liabakken"},{"name":"Skøyen stasjon"},{"name":"Sjølyst"},{"name":"Sjølyst"},{"name":"Thune"},{"name":"Maritim"},{"name":"Vækerø"},{"name":"Vækerø"},{"name":"Lilleaker"},{"name":"CC vest"},{"name":"Vækerøveien"},{"name":"Lysaker bru"},{"name":"Volvat"},{"name":"Borgen"},{"name":"Heggeli"},{"name":"Smestad"},{"name":"Bjørnsletta"},{"name":"Lyseveien"},{"name":"Lysejordet"},{"name":"Møllefaret"}]
            };

            query = query.toLowerCase();
            var foundFirstLetter = [];
            var foundOther = [];
            var found = _.filter(data[triggerChar], function(item) { return item.name.toLowerCase().indexOf(query) > -1; });

            for(var i = 0; i < found.length; i++) {
                if(found[i].name.toLocaleLowerCase().charAt(0) == query.toLocaleLowerCase().charAt(0)){
                    foundFirstLetter.push(found[i]);
                }
                else {
                    foundOther.push(found[i]);
                }
            }

            foundFirstLetter.sort(sortAlphabetically);
            foundOther.sort(sortAlphabetically);

            var allSorted = foundFirstLetter.concat(foundOther);
            callback.call(this, allSorted);
        }
    });

    var sortAlphabetically = function(a, b) {
        var A = a.name.toLocaleLowerCase();
        var B = b.name.toLocaleLowerCase();
        if(A < B) return -1;
        else if(A > B) return 1;
        else return 0;
    };

    $("textarea#query").keypress(function(event) {

        if($('.textntags-tag-list').css('display') == 'block') {
            return;
        }

        if(event.keyCode == 13) {
            event.preventDefault();
            $("#searchbutton").click();
            return false;
        }
    });

    $('#searchbutton').click(function() {

        var query = JSON.stringify({
            query: $('textarea#query').val()
        });

        $.ajax({
            url: "/search",
            contentType: 'application/json; charset=utf-8',
            dataType: 'json',
            type: 'POST',
            data: query,
            success: function(resultJson) {
                $("#message").html(resultJson.busstuc);
                calculateRoute(resultJson.route, resultJson.departures);
                showResultMessage();
            }
        });
    });

    $('#lastresult').click(function() {
        showResultMessage();
    });


    var showResultMessage = function() {
        $('#modalform').modal('toggle');
    }

    $('#helpbutton').click(function() {
        showHelpMessage();
    })

    var showHelpMessage = function() {
        $('#helpmodal').modal('toggle');
    }

    $('#modalform').on('hidden.bs.modal', function () {
        $('#query').focus();
    });

    $('#modalform').on('shown.bs.modal', function () {
        $('#query').blur();
        $('#closemodal').focus();
    });

    /*
     Google Maps
     */

    var map;
    var directionsDisplay;
    var directionsService = new google.maps.DirectionsService();
    var userLocation;
    var userLocationDot;

    var initialize = function() {

        directionsDisplay = new google.maps.DirectionsRenderer({suppressMarkers: true});

        var mapOptions = {
            center: new google.maps.LatLng(59.9154719, 10.7623614),
            zoom: 13,
            streetViewControl: false,
            mapTypeControl: false,

            panControl: true,
            panControlOptions: {
                position: google.maps.ControlPosition.RIGHT_BOTTOM
            },

            zoomControl: true,
            zoomControlOptions: {
                position: google.maps.ControlPosition.RIGHT_BOTTOM
            }
        };
        map = new google.maps.Map(document.getElementById("map-canvas"), mapOptions);
        directionsDisplay.setMap(map);
    }

    function getLocation() {
        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function(position) {
                var userCircle = {
                    strokeColor: '#333',
                    strokeOpacity: 0.3,
                    strokeWeight: 1,
                    fillColor: '#0099FF',
                    fillOpacity: 0.20,
                    map: map,
                    center: new google.maps.LatLng(position.coords.latitude, position.coords.longitude),
                    radius: Math.sqrt(20) * 20
                };

                var userDot = {
                    strokeColor: '#333',
                    strokeOpacity: 0.6,
                    strokeWeight: 10,
                    fillColor: '#000000',
                    fillOpacity: 0.0,
                    map: map,
                    center: new google.maps.LatLng(position.coords.latitude, position.coords.longitude),
                    radius: Math.sqrt(1) * 1
                };

                // Add the circle for this city to the map.
                userLocation = new google.maps.Circle(userCircle);
                userLocationDot = new google.maps.Circle(userDot);
            });
        }
    }

    var calculateRoute = function(route, departures) {

        if(route == null) return;

        // Google API v3 only allows 10 locations per request. Start and Stop plus 8 waypoints
        var locationsPerBatch = 10;
        var cleanRoute = [];

        for(var i = 0; i < route.length; i++) {
            if(route[i].name == "Meldepunkt")
                continue;

            if(route[i].xcoord.indexOf('.') == 1 || route[i].ycoord.indexOf('.') == 1)
                continue;

            if(route[i].xcoord == "null" || route[i].ycoord == "null")
                continue;

            cleanRoute.push(route[i]);
        }

        var batches = createBatchesOfRoute(cleanRoute, locationsPerBatch);
        postMapsRequest(batches, cleanRoute, departures);
    }

    var createBatchesOfRoute = function(route, locationsPerBatch) {

        var batches = []
        var itemsIndexCounter = 0;
        var waypointsExist = route.length > 0;

        while(waypointsExist) {
            var batch = [];
            var batchItemsCounter = 0;

            for(var i = itemsIndexCounter; i < route.length; i++) {
                batchItemsCounter++;

                batch.push({
                    location: new google.maps.LatLng(route[i].xcoord, route[i].ycoord),
                    stopover: true
                });

                if(batchItemsCounter == locationsPerBatch)
                    break;
            }

            batches.push(batch);
            itemsIndexCounter += batchItemsCounter;
            waypointsExist = itemsIndexCounter < route.length;

            // If there are more items in the list, start with the previous
            // last point to make sure we have two points in a request
            itemsIndexCounter--;
        }

        return batches;
    }


    // Post routes to google and display the result
    var postMapsRequest = function(routeBatches, cleanRoute, departures) {

        var departureIndex = -1;

        for(var i = 0; i < routeBatches.length; i++) {
            var request = createMapsRequest(routeBatches[i]);

            var combinedResults;
            var unsortedResults = [];
            var directionsResultsReturned = 0;

            directionsService.route(request, function(result, status) {

                if(status == "ZERO_RESULTS") {
                }

                if(status != google.maps.DirectionsStatus.OK) {
                    return;
                }

                var unsortedResult = { order: i, result: result };

                unsortedResults.push(unsortedResult);
                directionsResultsReturned++;

                if(directionsResultsReturned == routeBatches.length) {
                    removeAllActiveMarkers();

                    unsortedResults.sort(function(a, b) { return parseFloat(a.order) - parseFloat(b.order); });

                    var count = 0;

                    for(var key in unsortedResults) {

                        if(unsortedResults[key] == null) continue;
                        if(!unsortedResults.hasOwnProperty(key)) continue;

                        if(count == 0) {
                            combinedResults = unsortedResults[key].result;
                        }
                        else {
                            combinedResults.routes[0].legs = combinedResults.routes[0].legs.concat(unsortedResults[key].result.routes[0].legs);
                            combinedResults.routes[0].overview_path = combinedResults.routes[0].overview_path.concat(unsortedResults[key].result.routes[0].overview_path);

                            combinedResults.routes[0].bounds = combinedResults.routes[0].bounds.extend(unsortedResults[key].result.routes[0].bounds.getNorthEast());
                            combinedResults.routes[0].bounds = combinedResults.routes[0].bounds.extend(unsortedResults[key].result.routes[0].bounds.getSouthWest());
                        }
                        count++;
                    }

                    directionsDisplay.setDirections(combinedResults);

                    var legs = combinedResults.routes[0].legs;

                    // Keep track of markers
                    var charRoundtripIndex = 0;
                    // Create custom markers for each individual bus stop
                    for(var markerIndex = 0; markerIndex < legs.length + 1; markerIndex++) {

                        var markerLetter = "A".charCodeAt(0);
                        var charIndex = markerLetter + markerIndex;

                        // When getting to marker 'Z', begin on 'A' again
                        if(markerIndex % 26 == 0 && markerIndex != 0) {
                            charRoundtripIndex++;
                        }

                        charIndex = charIndex - (26 * charRoundtripIndex);
                        markerLetter = String.fromCharCode(charIndex);

                        var iconSuffix = "_Marker" + markerLetter.toUpperCase();
                        var color = "red";

                        if(cleanRoute[markerIndex].role == "enter") {
                            departureIndex++;
                            if(markerIndex != 0) color = "green";
                            else color = "darkgreen";
                        }
                        else if(cleanRoute[markerIndex].role == "exit") {
                            color = "red";
                        }
                        else if(cleanRoute[markerIndex].role == "pass") {
                            color = "blue";
                        }

                        var marker_location = markerIndex < legs.length ? legs[markerIndex].start_location : legs[markerIndex-1].end_location;
                        var marker_address = markerIndex < legs.length ? legs[markerIndex].start_address : legs[markerIndex-1].end_address;
                        var bus = "Bus: " + "<strong>" + departures[departureIndex].busnumber + "</strong> from <strong>" + departures[departureIndex].busstopname + "</strong> to <strong>" + departures[departureIndex].destination + "</strong>";

                        var markerText = "<strong>" + cleanRoute[markerIndex].name + "</strong>" + "<br>" + "<br>" + bus + "<br>" + marker_address;
                        var iconName = color + iconSuffix;

                        createMarker(directionsDisplay.getMap(), marker_location, "Bus stop " + (markerIndex+1), markerText, iconName);
                    }
                }
            });
        }
    }


    // Create a google maps request from a batch of routes
    var createMapsRequest = function(routeBatch) {

        var start = routeBatch[0].location;
        var end = routeBatch[routeBatch.length - 1].location;

        // Remove start and end from waypoints
        var waypoints = routeBatch;
        waypoints.splice(0, 1);
        waypoints.splice(waypoints.length -1, 1);

        // Create the request
        var request = {
            origin: start,
            destination: end,
            waypoints: waypoints,
            travelMode: google.maps.TravelMode.DRIVING,
            unitSystem: google.maps.UnitSystem.METRIC
        };

        return request;
    }

    var infowindow = new google.maps.InfoWindow({
            size: new google.maps.Size(150,50)
        }
    );

    var icons = new Array();
    icons["red"] = new google.maps.MarkerImage("mapIcons/marker_red.png",
        // This marker is 20 pixels wide by 34 pixels tall.
        new google.maps.Size(20, 34),
        // The origin for this image is 0,0.
        new google.maps.Point(0,0),
        // The anchor for this image is at 9,34.
        new google.maps.Point(9, 34)
    );

    function getMarkerImage(iconStr) {

        if ((typeof(iconStr)=="undefined") || (iconStr==null)) {
            iconStr = "red";
        }

        if (!icons[iconStr]) {
            icons[iconStr] = new google.maps.MarkerImage("/static/img/maps/"+ iconStr +".png",
                new google.maps.Size(20, 34),
                new google.maps.Point(0,0), // Origin
                new google.maps.Point(9, 34) // Anchor
            );
        }
        return icons[iconStr];
    }

    var iconImage = new google.maps.MarkerImage('mapIcons/marker_red.png',
        new google.maps.Size(20, 34),
        new google.maps.Point(0,0),
        new google.maps.Point(9, 34)
    );

    var iconShape = {
        coord: [9,0,6,1,4,2,2,4,0,8,0,12,1,14,2,16,5,19,7,23,8,26,9,30,9,34,11,34,11,30,12,26,13,24,14,21,16,18,18,16,20,12,20,8,18,4,16,2,15,1,13,0],
        type: 'poly'
    };

    function createMarker(map, latlng, label, html, color) {
        var contentString = '<b>'+label+'</b><br>'+html;
        var marker = new google.maps.Marker({
            position: latlng,
            map: map,
            shadow: null,
            icon: getMarkerImage(color),
            shape: iconShape,
            title: label,
            zIndex: Math.round(latlng.lat()*-100000)<<5
        });
        marker.myname = label;

        google.maps.event.addListener(marker, 'click', function() {
            infowindow.setContent(contentString);
            infowindow.open(map,marker);
        });

        active_markers.push(marker);

        return marker;
    }

    var active_markers = [];

    var removeAllActiveMarkers = function() {
        for(var i = 0; i < active_markers.length; i++) {
            active_markers[i].setMap(null);
        }
    }

    // Load google maps
    google.maps.event.addDomListener(window, 'load', initialize());
});