package PrologConverter;

import PrologConverter.regpas.RegPasBase;
import RegToppParser.control.ParseManager;
import RegToppParser.settings.Settings;

/**
 * Created on 17.11.14.
 * @author Espen Jacobsson
 */
public class Main {


    public static void main(String[] args) {
        long now = System.currentTimeMillis();
        ParseManager manager = new ParseManager(Settings.REGTOPP_ROOT_PATH);
        manager.registerListeners(new RegHpl(), new RegBus(), new RegDko(), new RegPasBase());
        manager.performParsing();

        System.out.println(System.currentTimeMillis() - now + "ms");
    }
}
