package RegToppParser.models;

/**
 * Created on 15.11.14.
 * @author Espen Jacobsson
 */
public enum FileType {
	
	DKO("DKO"), // DAGKODE, Dagkode
	DST("DST"), // DESTNAVN, Destinasjon
	FRM("FRM"), // FORMPAR, Formatparameter
	GAV("GAV"), // GANGVEI, Gangvei
	HPL("HPL"), // HPL, Holdeplass
	LIN("LIN"), // LINJE, Linje
	MRK("MRK"), // MERKNAD, Merknad
	PER("PER"), // PERIODE, Periode
	RUT("RUT"), // RUTEPKT, Rutepunkt
	SAM("SAM"), // SAMTFK, Samtrafikk
	SON("SON"), // SONE, Sone
	TAB("TAB"), // TABVER, Tabellversjon
    TDA("TDA"), // TURDATA, Turdata
	TIX("TIX"), // TURIX, Turindex
	TMS("TMS"), // TURMSTR, Turmønster
	VLP("VLP"), // VOGNLØP, Vognløp
    STP("STP"); // STOP POINTS, Stop points
	
	
	private String fileType;
	
	private FileType(String fileType) {
		this.fileType = fileType;
	}
}
