package RegToppParser.models.regtopp;


import RegToppParser.control.FileTaskDelegator;
import RegToppParser.interfaces.RegToppFileParser;
import RegToppParser.models.Field;
import RegToppParser.models.FileType;
import RegToppParser.models.Version;

import java.io.File;

/**
 * Created on 15.11.14.
 * @author Espen Jacobsson
 */
public class DST extends RegToppObject implements RegToppFileParser {


    public DST(Version version) {
        super(version, Field.getFieldsForFileTypeAndVersion(FileType.DST, version));
        FileTaskDelegator.getInstance().registerFileParser(this, FileType.DST);
    }


    public boolean parse(File file) {
        return super.parseFile(file);
    }
}
