package RegToppParser.models.regtopp;

import java.io.File;

import RegToppParser.control.FileTaskDelegator;
import RegToppParser.interfaces.RegToppFileParser;
import RegToppParser.models.Field;
import RegToppParser.models.FileType;
import RegToppParser.models.Version;

/**
 * Created on 15.11.14.
 * @author Espen Jacobsson
 */
public class PER extends RegToppObject implements RegToppFileParser {


    public PER(Version version) {
        super(version, Field.getFieldsForFileTypeAndVersion(FileType.PER, version));
        FileTaskDelegator.getInstance().registerFileParser(this, FileType.PER);
    }
    

    public boolean parse(File file) {
        return super.parseFile(file);
    }
}
