package RegToppParser.models.regtopp;

import RegToppParser.control.FileTaskDelegator;
import RegToppParser.interfaces.RegToppFileParser;
import RegToppParser.models.Field;
import RegToppParser.models.FileType;
import RegToppParser.models.Version;

import java.io.File;

/**
 * Created on 15.11.14.
 * @author Espen Jacobsson
 */
public class RUT extends RegToppObject implements RegToppFileParser {
    
    
    public RUT(Version version) {
        super(version, Field.getFieldsForFileTypeAndVersion(FileType.RUT, version));
        FileTaskDelegator.getInstance().registerFileParser(this, FileType.RUT);
    }


    public boolean parse(File file) {
        return super.parseFile(file);
    }
}
