package RegToppParser.models.regtopp;

import RegToppParser.control.FileTaskDelegator;
import RegToppParser.interfaces.RegToppFileParser;
import RegToppParser.models.Field;
import RegToppParser.models.FileType;
import RegToppParser.models.Post;
import RegToppParser.models.Version;

import java.io.File;
import java.util.List;

/**
 * Created on 15.11.14.
 * @author Espen Jacobsson
 */
public class TMS extends RegToppObject implements RegToppFileParser {
    
    
    public TMS(Version version) {
        super(version, Field.getFieldsForFileTypeAndVersion(FileType.TMS, version));
        FileTaskDelegator.getInstance().registerFileParser(this, FileType.TMS);
    }


    public boolean parse(File file) {
        return super.parseFile(file);
    }
}
