package no.oslotuc.net.urls;

import no.oslotuc.apps.ajaxtest.AjaxUrls;
import no.oslotuc.apps.index.IndexUrls;
import no.oslotuc.apps.logviewer.LogUrls;
import no.oslotuc.apps.search.SearchUrls;
import no.oslotuc.apps.static_files.StaticUrls;

import java.util.ArrayList;
import java.util.List;

public class Urls {


    public static final List<UrlPattern> URLS = new ArrayList<UrlPattern>() {{


        /* Index patterns */
        this.addAll(IndexUrls.URL_PATTERNS);


        /* Static patterns */
        this.addAll(StaticUrls.URL_PATTERNS);


        /* Ajax patterns */
        this.addAll(AjaxUrls.URL_PATTERNS);


        /* Search patterns */
        this.addAll(SearchUrls.URL_PATTERNS);


        /* Log patterns */
        this.addAll(LogUrls.URL_PATTERNS);

    }};

}
