package no.oslotuc.util;

import fi.iki.elonen.NanoHTTPD;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class SessionReader {

    public static String getAjaxPostData(NanoHTTPD.IHTTPSession session) {
        Map<String, String> post = new HashMap<>();

        try {
            session.parseBody(post);
        } catch (IOException e) {
            e.printStackTrace();
        } catch (NanoHTTPD.ResponseException e) {
            e.printStackTrace();
        }


        if(post.containsKey("postData")) {
            return post.get("postData");
        }

        return "";
    }
}
