$(function() {

    $.ajax({
        url: "/givemelogs/get",
        type: 'GET',
        success: function(resultJson) {

            for(var i = 0; i < resultJson.length; i++) {
                createLogEntry(resultJson[i]);
            }

        }
    });


    var createLogEntry = function(logEntry) {

        var date = new Date(logEntry.startTime);

        var html =
            "<div class='panel-group' id='"+ logEntry.startTime + "'>" +
                "<div class='panel panel-default'>" +
                    "<div class='panel-heading' data-toggle='collapse' data-parent='#" + logEntry.startTime + "' data-target='#collapseOuter" + logEntry.startTime + "'>" +
                        "<h4 class='panel-title'>" +
                            "<a class='accordion-toggle'>" +
                                logEntry.question +
                            "</a>" +
                        "</h4>" +
                    "</div>" +
                    "<div id='collapseOuter" + logEntry.startTime + "' class='panel-collapse collapse'>" +
                        "<div class='panel-body'>" +
                            "<div class='row row-space'>" +
                                "<div class='col-md-12'>" +
                                    "<div class='input-group'>" +
                                        "<span class='input-group-addon'>Question</span>" +
                                        "<input class='form-control' value='" + logEntry.question + "'>" +
                                    "</div>" +
                                "</div>" +
                            "</div>" +
                            "<div class='row row-space'>" +
                                "<div class='col-md-12'>" +
                                    "<div class='input-group'>" +
                                        "<span class='input-group-addon'>Time</span>" +
                                        "<input class='form-control' value='" + date + "'>" +
                                    "</div>" +
                                "</div>" +
                            "</div>" +
                            "<div class='row row-space'>" +
                                "<div class='col-md-4'>" +
                                    "<div class='input-group'>" +
                                        "<span class='input-group-addon'>Start time (ms)</span>" +
                                        "<input class='form-control' value='" + logEntry.startTime + "'>" +
                                    "</div>" +
                                "</div>" +
                                "<div class='col-md-4'>" +
                                    "<div class='input-group'>" +
                                        "<span class='input-group-addon'>End time (ms)</span>" +
                                        "<input class='form-control' value='" + logEntry.endTime + "'>" +
                                    "</div>" +
                                "</div>" +
                                "<div class='col-md-4'>" +
                                    "<div class='input-group'>" +
                                        "<span class='input-group-addon'>Total time (ms)</span>" +
                                        "<input class='form-control' value='" + logEntry.totalTime + "'>" +
                                    "</div>" +
                                "</div>" +
                            "</div>" +
                            "<div class='row row-space'>" +
                                "<div class='col-md-12'>" +
                                    "<div class='panel-group' id='inner" + logEntry.startTime + "'>" +
                                        "<div class='panel panel-default'>" +
                                            "<div class='panel-heading' data-toggle='collapse' data-parent='#inner" + logEntry.startTime + "' data-target='#collapseinner" + logEntry.startTime + "'>" +
                                                "<h4 class='panel-title'>" +
                                                    "<a class='accordion-toggle'>" +
                                                        "Answer" +
                                                    "</a>" +
                                                "</h4>" +
                                            "</div>" +
                                            "<div id='collapseinner" + logEntry.startTime + "' class='panel-collapse collapse'>" +
                                                "<div class='panel-body'>" +
                                                    "<div class='row'>" +
                                                        "<div class='col-md-12'>" +
                                                            "<pre>" + syntaxHighlight(logEntry.answer) + "</pre>" +
                                                        "</div>" +
                                                    "</div>" +
                                                "</div>" +
                                            "</div>" +
                                        "</div>" +
                                    "</div>" +
                                "</div>" +
                            "</div>" +
                        "</div>" +
                    "</div>" +
                "</div>" +
            "</div>";

        $('#body.container-fluid').append(html);
    }

    var syntaxHighlight = function(json) {
        if (typeof json != 'string') {
            json = JSON.stringify(json, undefined, 2);
        }
        json = json.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
        return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
            var cls = 'number';
            if (/^"/.test(match)) {
                if (/:$/.test(match)) {
                    cls = 'key';
                } else {
                    cls = 'string';
                }
            } else if (/true|false/.test(match)) {
                cls = 'boolean';
            } else if (/null/.test(match)) {
                cls = 'null';
            }
            return '<span class="' + cls + '">' + match + '</span>';
        });
    }
});