/* -*- Mode:Prolog; coding:utf-8; -*- */
%% FILE regcompstr.pl
%% SYSTEM BussTUC
%% CREATED EJ-06102014 Automatic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
:-module(regcompstr, [
        composite_road/3
]).

composite_road(juni,[plassen],juni_plassen).
composite_road(aagots,[street],aagots_street).
composite_road(aasmund,[vinjes,street],aasmund_vinjes_street).
composite_road(aasta,[hansteens,street],aasta_hansteens_street).
composite_road(abbediengen,[terrasse],abbediengen_terrasse).
composite_road(abbediengveien,[],abbedieng_street).
composite_road(abbedikollen,[],abbedikollen).
composite_road(abbedisvingen,[],abbedisvingen).
composite_road(abildsøfaret,[],abildsøfaret).
composite_road(abildsøveien,[],abildsø_street).
composite_road(adam,[hiorths,street],adam_hiorths_street).
composite_road(admiral,[børresens,street],admiral_børresens_street).
composite_road(adventveien,[],advent_street).
composite_road(agathe,[grøndahls,street],agathe_grøndahls_street).
composite_road(agdergata,[],agder_street).
composite_road(agmund,[bolts,street],agmund_bolts_street).
composite_road(agronomveien,[],agronom_street).
composite_road(akebakkeskogen,[],akebakkeskogen).
composite_road(akerlia,[],akerlia).
composite_road(akersbakken,[],akersbakken).
composite_road(akersborg,[terrasse],akersborg_terrasse).
composite_road(akersgata,[],akers_street).
composite_road(akershusstranda,[],akershusstranda).
composite_road(akersveien,[],akers_street).
composite_road(albert,[nordengens,plass],albert_nordengens_plass).
composite_road(alf,[bjerckes,street],alf_bjerckes_street).
composite_road(alf,[bjerckes,street],alf_bjerckes_street).
composite_road(alfaset,[1,industrivei],alfaset_1_industri_street).
composite_road(alfaset,[3,industrivei],alfaset_3_industri_street).
composite_road(alfasetveien,[],alfaset_street).
composite_road(almeveien,[],alme_street).
composite_road(alnabruveien,[],alnabru_street).
composite_road(alnafetgata,[],alnafet_street).
composite_road(alnagata,[],alna_street).
composite_road(alnaparkveien,[],alnapark_street).
composite_road(alundamveien,[],alundam_street).
composite_road(alunsjøveien,[],alunsjø_street).
composite_road(alvheimveien,[],alvheim_street).
composite_road(amagerveien,[],amager_street).
composite_road(ammerudgrenda,[],ammerudgrenda).
composite_road(ammerudhellinga,[],ammerudhellinga).
composite_road(ammerudveien,[],ammerud_street).
composite_road(amtmann,[meinichs,street],amtmann_meinichs_street).
composite_road(amund,[hellands,street],amund_hellands_street).
composite_road(anders,[winsvolds,street],anders_winsvolds_street).
composite_road(ankerveien,[],anker_street).
composite_road(anna,[pleyms,street],anna_pleyms_street).
composite_road(anna,[rogstads,street],anna_rogstads_street).
composite_road(anna,[sethnes,street],anna_sethnes_street).
composite_road(anne,[maries,street],anne_maries_street).
composite_road(ansgar,[sørlies,street],ansgar_sørlies_street).
composite_road(antenneveien,[],antenne_street).
composite_road(anton,[schjøths,street],anton_schjøths_street).
composite_road(anton,[tschudis,street],anton_tschudis_street).
composite_road(apalløkkveien,[],apalløkk_street).
composite_road(apalveien,[],apal_street).
composite_road(apalveien,[],apal_street).
composite_road(apotekergata,[],apoteker_street).
composite_road(arbeidergata,[],arbeider_street).
composite_road(arbeidersamfunnets,[plass],arbeidersamfunnets_plass).
composite_road(arbins,[street],arbins_street).
composite_road(arbins,[street],arbins_street).
composite_road(arbos,[street],arbos_street).
composite_road(arctanders,[street],arctanders_street).
composite_road(arendalsgata,[],arendals_street).
composite_road(arilds,[street],arilds_street).
composite_road(arildsvingen,[],arildsvingen).
composite_road(arkitekt,[steckmests,street],arkitekt_steckmests_street).
composite_road(armauer,[hansens,street],armauer_hansens_street).
composite_road(arne,[garborgs,plass],arne_garborgs_plass).
composite_road(arne,[garborgs,street],arne_garborgs_street).
composite_road(arnebråtveien,[],arnebråt_street).
composite_road(arnes,[street],arnes_street).
composite_road(arnljot,[gellines,street],arnljot_gellines_street).
composite_road(arnstein,[arnebergs,street],arnstein_arnebergs_street).
composite_road(arnulf,[øverlands,street],arnulf_øverlands_street).
composite_road(arthur,[nordlies,street],arthur_nordlies_street).
composite_road(arups,[street],arups_street).
composite_road(arvesetveien,[],arveset_street).
composite_road(asalveien,[],asal_street).
composite_road(asbjørnsens,[street],asbjørnsens_street).
composite_road(aschehougs,[street],aschehougs_street).
composite_road(askeladdveien,[],askeladd_street).
composite_road(askergata,[],asker_street).
composite_road(askeveien,[],aske_street).
composite_road(aslakveien,[],aslak_street).
composite_road(aslaug,[vaas,street],aslaug_vaas_street).
composite_road(aspehaugveien,[],aspehaug_street).
composite_road(asperudlia,[],asperudlia).
composite_road(asperudtoppen,[],asperudtoppen).
composite_road(asperudveien,[],asperud_street).
composite_road(asperudåsen,[],asperudåsen).
composite_road(aspestien,[],aspestien).
composite_road(astrids,[street],astrids_street).
composite_road(august,[cappelens,street],august_cappelens_street).
composite_road(aurskoggata,[],aurskog_street).
composite_road(austliveien,[],austli_street).
composite_road(avlangruds,[street],avlangruds_street).
composite_road(avstikkeren,[],avstikkeren).
composite_road(axel,[brinchs,street],axel_brinchs_street).
composite_road(axel,[flinders,street],axel_flinders_street).
composite_road(axel,[huitfeldts,street],axel_huitfeldts_street).
composite_road(badebakken,[],badebakken).
composite_road(badstugata,[],badstu_street).
composite_road(baglerfaret,[],baglerfaret).
composite_road(baglerstredet,[],baglerstredet).
composite_road(bakkehaugveien,[],bakkehaug_street).
composite_road(bakkerudveien,[],bakkerud_street).
composite_road(bakketoppen,[],bakketoppen).
composite_road(bakkeveien,[],bakke_street).
composite_road(balchens,[street],balchens_street).
composite_road(balders,[street],balders_street).
composite_road(ballplassveien,[],ballplass_street).
composite_road(bamseveien,[],bamse_street).
composite_road(baneveien,[],bane_street).
composite_road(bankplassen,[],bankplassen).
composite_road(banksjef,[frølichs,street],banksjef_frølichs_street).
composite_road(barliveien,[],barli_street).
composite_road(barnehjemsveien,[],barnehjems_street).
composite_road(barnålveien,[],barnål_street).
composite_road(bauneveien,[],baune_street).
composite_road(beddingen,[],beddingen).
composite_road(bedriftsveien,[],bedrifts_street).
composite_road(behrens,[street],behrens_street).
composite_road(beiteveien,[],beite_street).
composite_road(bekkefaret,[],bekkefaret).
composite_road(bekkelagsterrassen,[],bekkelagsterrassen).
composite_road(bekkelagsveien,[],bekkelags_street).
composite_road(bekkelibakken,[],bekkelibakken).
composite_road(bekkelikroken,[],bekkelikroken).
composite_road(bekkelistubben,[],bekkelistubben).
composite_road(bekkeliveien,[],bekkeli_street).
composite_road(bekkenstenveien,[],bekkensten_street).
composite_road(bekkeveien,[],bekke_street).
composite_road(bekkevollveien,[],bekkevoll_street).
composite_road(belgerudveien,[],belgerud_street).
composite_road(benneches,[street],benneches_street).
composite_road(bentsebrugata,[],bentsebru_street).
composite_road(bentsegata,[],bentse_street).
composite_road(benveien,[],ben_street).
composite_road(bergensgata,[],bergens_street).
composite_road(bergensveien,[],bergens_street).
composite_road(bergkrystallen,[],bergkrystallen).
composite_road(bergljots,[street],bergljots_street).
composite_road(berglyveien,[],bergly_street).
composite_road(bergrådveien,[],bergråd_street).
composite_road(bergsalleen,[],bergsalleen).
composite_road(bergslia,[],bergslia).
composite_road(bergsliens,[street],bergsliens_street).
composite_road(bergstien,[],bergstien).
composite_road(bergtunveien,[],bergtun_street).
composite_road(bergverksgata,[],bergverks_street).
composite_road(bernhard,[getz,street],bernhard_getz_street).
composite_road(bernhard,[herres,street],bernhard_herres_street).
composite_road(bernhusveien,[],bernhus_street).
composite_road(bernt,[ankers,street],bernt_ankers_street).
composite_road(bernt,[knudsens,street],bernt_knudsens_street).
composite_road(bertramjordet,[],bertramjordet).
composite_road(bertrand,[narvesens,street],bertrand_narvesens_street).
composite_road(bertrand,[narvesens,street],bertrand_narvesens_street).
composite_road(bervens,[løkke],bervens_løkke).
composite_road(bestemorstien,[],bestemorstien).
composite_road(bestum,[skolevei],bestum_skole_street).
composite_road(bestum,[tverrvei],bestum_tverr_street).
composite_road(bestumstubben,[],bestumstubben).
composite_road(bestumveien,[],bestum_street).
composite_road(bestumåsen,[],bestumåsen).
composite_road(betzy,[kjelsbergs,street],betzy_kjelsbergs_street).
composite_road(beverkollen,[],beverkollen).
composite_road(beverveien,[],bever_street).
composite_road(bidenkaps,[street],bidenkaps_street).
composite_road(biermanns,[street],biermanns_street).
composite_road(biermanns,[street],biermanns_street).
composite_road(bikuben,[],bikuben).
composite_road(bilittkroken,[],bilittkroken).
composite_road(binneveien,[],binne_street).
composite_road(birch,[reichenwalds,street],birch_reichenwalds_street).
composite_road(birger,[aaneruds,street],birger_aaneruds_street).
composite_road(birger,[olivers,street],birger_olivers_street).
composite_road(birgitte,[hammers,street],birgitte_hammers_street).
composite_road(biskop,[grimelunds,street],biskop_grimelunds_street).
composite_road(biskop,[gunnerus,street],biskop_gunnerus_street).
composite_road(biskop,[heuchs,street],biskop_heuchs_street).
composite_road(biskop,[jens,nilssøns,street],biskop_jens_nilssøns_street).
composite_road(bislettgata,[],bislett_street).
composite_road(bisp,[nikolas,street],bisp_nikolas_street).
composite_road(bispegata,[],bispe_street).
composite_road(bispeluelia,[],bispeluelia).
composite_road(bjartveien,[],bjart_street).
composite_road(bjerkastien,[],bjerkastien).
composite_road(bjerkealleen,[],bjerkealleen).
composite_road(bjerkebakken,[],bjerkebakken).
composite_road(bjerkefaret,[],bjerkefaret).
composite_road(bjerkelia,[],bjerkelia).
composite_road(bjerkeliveien,[],bjerkeli_street).
composite_road(bjerkelundgata,[],bjerkelund_street).
composite_road(bjerregaards,[street],bjerregaards_street).
composite_road(bjerringbakken,[],bjerringbakken).
composite_road(bjølsengata,[],bjølsen_street).
composite_road(bjørkehavna,[],bjørkehavna).
composite_road(bjørn,[bondes,street],bjørn_bondes_street).
composite_road(bjørn,[farmanns,street],bjørn_farmanns_street).
composite_road(bjørn,[lies,street],bjørn_lies_street).
composite_road(bjørn,[stallares,street],bjørn_stallares_street).
composite_road(bjørndalsjordet,[],bjørndalsjordet).
composite_road(bjørnefaret,[],bjørnefaret).
composite_road(bjørnehiet,[],bjørnehiet).
composite_road(bjørnerabben,[],bjørnerabben).
composite_road(bjørnerudveien,[],bjørnerud_street).
composite_road(bjørnheimveien,[],bjørnheim_street).
composite_road(bjørnslettstubben,[],bjørnslettstubben).
composite_road(bjørnslettveien,[],bjørnslett_street).
composite_road(bjørnstadbakken,[],bjørnstadbakken).
composite_road(bjørnstjerne,[bjørnsons,plass],bjørnstjerne_bjørnsons_plass).
composite_road(bjørnveien,[],bjørn_street).
composite_road(bjørnåsveien,[],bjørnås_street).
composite_road(blakkens,[street],blakkens_street).
composite_road(bleikøya,[],bleikøya).
composite_road(blindernveien,[],blindern_street).
composite_road(blindernveien,[],blindern_street).
composite_road(blokkaveien,[],blokka_street).
composite_road(blåbærsvingen,[],blåbærsvingen).
composite_road(blåsbortveien,[],blåsbort_street).
composite_road(blåskjellveien,[],blåskjell_street).
composite_road(bodøgata,[],bodø_street).
composite_road(bogerudslyngen,[],bogerudslyngen).
composite_road(bogerudveien,[],bogerud_street).
composite_road(bogstadveien,[],bogstad_street).
composite_road(bolette,[brygge],bolette_brygge).
composite_road(bolteløkka,[alle],bolteløkka_alle).
composite_road(bomveien,[],bom_street).
composite_road(borgenbakken,[],borgenbakken).
composite_road(borgenveien,[],borgen_street).
composite_road(borger,[withs,street],borger_withs_street).
composite_road(borgestadveien,[],borgestad_street).
composite_road(borggata,[],borg_street).
composite_road(brageveien,[],brage_street).
composite_road(brandts,[street],brandts_street).
composite_road(brannfjellveien,[],brannfjell_street).
composite_road(brannfjellveien,[],brannfjell_street).
composite_road(brannvaktveien,[],brannvakt_street).
composite_road(brantenborgveien,[],brantenborg_street).
composite_road(brattbakken,[],brattbakken).
composite_road(brattelia,[],brattelia).
composite_road(brattlistubben,[],brattlistubben).
composite_road(brattoddveien,[],brattodd_street).
composite_road(brattvollveien,[],brattvoll_street).
composite_road(bredes,[street],bredes_street).
composite_road(bredo,[stabells,street],bredo_stabells_street).
composite_road(bredtvetveien,[],bredtvet_street).
composite_road(bregneveien,[],bregne_street).
composite_road(breidablikkveien,[],breidablikk_street).
composite_road(breiens,[street],breiens_street).
composite_road(breigata,[],brei_street).
composite_road(breisjåveien,[],breisjå_street).
composite_road(breivollveien,[],breivoll_street).
composite_road(brekkelia,[],brekkelia).
composite_road(brekkeveien,[],brekke_street).
composite_road(brennagrenda,[],brennagrenda).
composite_road(brennastubben,[],brennastubben).
composite_road(brennaveien,[],brenna_street).
composite_road(brenneriveien,[],brenneri_street).
composite_road(brettevilles,[street],brettevilles_street).
composite_road(brinken,[],brinken).
composite_road(briskebyveien,[],briskeby_street).
composite_road(brobekkveien,[],brobekk_street).
composite_road(brochmanns,[street],brochmanns_street).
composite_road(brolandsveien,[],brolands_street).
composite_road(brubakkveien,[],brubakk_street).
composite_road(brugata,[],bru_street).
composite_road(brugata,[],bru_street).
composite_road(brunas,[street],brunas_street).
composite_road(bryggegangen,[],bryggegangen).
composite_road(bryggegata,[],brygge_street).
composite_road(bryggetorget,[],bryggetorget).
composite_road(brynjeveien,[],brynje_street).
composite_road(brynjulf,[bulls,plass],brynjulf_bulls_plass).
composite_road(brynsalleen,[],brynsalleen).
composite_road(brynsengfaret,[],brynsengfaret).
composite_road(brynsengveien,[],brynseng_street).
composite_road(brynshøgda,[],brynshøgda).
composite_road(brynsveien,[],bryns_street).
composite_road(brønnveien,[],brønn_street).
composite_road(bråtenalleen,[],bråtenalleen).
composite_road(bueveien,[],bue_street).
composite_road(bukken,[bruses,street],bukken_bruses_street).
composite_road(bygdøy,[alle],bygdøy_alle).
composite_road(bygdøy,[alle],bygdøy_alle).
composite_road(bygdøy,[kapellvei],bygdøy_kapell_street).
composite_road(bygdøy,[terrasse],bygdøy_terrasse).
composite_road(bygdøylund,[],bygdøylund).
composite_road(bygdøynesveien,[],bygdøynes_street).
composite_road(bygdøyveien,[],bygdøy_street).
composite_road(byggveien,[],bygg_street).
composite_road(bærumsveien,[],bærums_street).
composite_road(bøgata,[],bø_street).
composite_road(bølerbakken,[],bølerbakken).
composite_road(bølerlia,[],bølerlia).
composite_road(bølerskogen,[],bølerskogen).
composite_road(bølerskrenten,[],bølerskrenten).
composite_road(bølersletta,[],bølersletta).
composite_road(bølersvingen,[],bølersvingen).
composite_road(bølerveien,[],bøler_street).
composite_road(børsteveien,[],børste_street).
composite_road(båhusveien,[],båhus_street).
composite_road(bålveien,[],bål_street).
composite_road(bånkallstubben,[],bånkallstubben).
composite_road(båntjernveien,[],båntjern_street).
composite_road(bård,[skolemesters,street],bård_skolemesters_street).
composite_road(c,[a,pihls,street],c_a_pihls_street).
composite_road(c,[a,torstensens,street],c_a_torstensens_street).
composite_road(c,[j,hambros,plass],c_j_hambros_plass).
composite_road(calmeyers,[street],calmeyers_street).
composite_road(camilla,[colletts,street],camilla_colletts_street).
composite_road(cappelens,[street],cappelens_street).
composite_road(carl,[berners,plass],carl_berners_plass).
composite_road(carl,[grøndahls,street],carl_grøndahls_street).
composite_road(carl,[jeppesens,street],carl_jeppesens_street).
composite_road(carl,[kjelsens,street],carl_kjelsens_street).
composite_road(carl,[lundgrens,street],carl_lundgrens_street).
composite_road(caspar,[storms,street],caspar_storms_street).
composite_road(casparis,[street],casparis_street).
composite_road(cecilie,[thoresens,street],cecilie_thoresens_street).
composite_road(charlotte,[andersens,street],charlotte_andersens_street).
composite_road(christian,[benneches,street],christian_benneches_street).
composite_road(christian,[frederiks,plass],christian_frederiks_plass).
composite_road(christian,[frederiks,street],christian_frederiks_street).
composite_road(christian,[krohgs,street],christian_krohgs_street).
composite_road(christian,[michelsens,street],christian_michelsens_street).
composite_road(christian,[michelsens,street],christian_michelsens_street).
composite_road(christian,[schous,street],christian_schous_street).
composite_road(christiania,[torv],christiania_torv).
composite_road(christies,[street],christies_street).
composite_road(christoffer,[hellums,street],christoffer_hellums_street).
composite_road(christopher,[hansteens,street],christopher_hansteens_street).
composite_road(christophers,[street],christophers_street).
composite_road(claus,[borchs,street],claus_borchs_street).
composite_road(claus,[riis,street],claus_riis_street).
composite_road(colbjørnsens,[street],colbjørnsens_street).
composite_road(colletts,[street],colletts_street).
composite_road(colletts,[street],colletts_street).
composite_road(conrad,[hemsens,street],conrad_hemsens_street).
composite_road(conradis,[street],conradis_street).
composite_road(cort,[adelers,street],cort_adelers_street).
composite_road(daas,[street],daas_street).
composite_road(dag,[hammarskjolds,street],dag_hammarskjolds_street).
composite_road(dag,[hammarskjolds,street],dag_hammarskjolds_street).
composite_road(dagalikroken,[],dagalikroken).
composite_road(dagaliveien,[],dagali_street).
composite_road(dagmarbakken,[],dagmarbakken).
composite_road(dalbakkveien,[],dalbakk_street).
composite_road(dalehaugen,[],dalehaugen).
composite_road(dalerudveien,[],dalerud_street).
composite_road(dalheimveien,[],dalheim_street).
composite_road(dalsbergstien,[],dalsbergstien).
composite_road(dalskroken,[],dalskroken).
composite_road(dalsløkka,[],dalsløkka).
composite_road(dalsnaret,[],dalsnaret).
composite_road(dalsroa,[],dalsroa).
composite_road(dalssvingen,[],dalssvingen).
composite_road(dalsveien,[],dals_street).
composite_road(dalsåsen,[],dalsåsen).
composite_road(damfaret,[],damfaret).
composite_road(damkroken,[],damkroken).
composite_road(damlihaugen,[],damlihaugen).
composite_road(damliveien,[],damli_street).
composite_road(dammanns,[street],dammanns_street).
composite_road(damplassen,[],damplassen).
composite_road(damstredet,[],damstredet).
composite_road(damveien,[],dam_street).
composite_road(daniel,[walstads,street],daniel_walstads_street).
composite_road(danmarks,[street],danmarks_street).
composite_road(dannevigsveien,[],dannevigs_street).
composite_road(darres,[street],darres_street).
composite_road(darres,[street],darres_street).
composite_road(deichmans,[street],deichmans_street).
composite_road(deichmans,[street],deichmans_street).
composite_road(delebekken,[],delebekken).
composite_road(diakonveien,[],diakon_street).
composite_road(diriks,[street],diriks_street).
composite_road(disengrenda,[],disengrenda).
composite_road(disenveien,[],disen_street).
composite_road(doktor,[baches,street],doktor_baches_street).
composite_road(doktor,[holms,street],doktor_holms_street).
composite_road(doktor,[londons,street],doktor_londons_street).
composite_road(doktor,[rustads,street],doktor_rustads_street).
composite_road(doktor,[smiths,street],doktor_smiths_street).
composite_road(dops,[street],dops_street).
composite_road(dorthes,[street],dorthes_street).
composite_road(dovregata,[],dovre_street).
composite_road(dovresvingen,[],dovresvingen).
composite_road(dr,[dedichens,street],dr_dedichens_street).
composite_road(dragonstien,[],dragonstien).
composite_road(drammensveien,[],drammens_street).
composite_road(drammensveien,[],drammens_street).
composite_road(drivhusveien,[],drivhus_street).
composite_road(dronning,[astrids,street],dronning_astrids_street).
composite_road(dronning,[blancas,street],dronning_blancas_street).
composite_road(dronning,[eufemias,street],dronning_eufemias_street).
composite_road(dronning,[eufemias,street],dronning_eufemias_street).
composite_road(dronning,[ingrids,plass],dronning_ingrids_plass).
composite_road(dronning,[mauds,street],dronning_mauds_street).
composite_road(dronningen,[],dronningen).
composite_road(dronningens,[street],dronningens_street).
composite_road(dronninghavnveien,[],dronninghavn_street).
composite_road(drøbakgata,[],drøbak_street).
composite_road(dråga,[],dråga).
composite_road(duehaugveien,[],duehaug_street).
composite_road(duggveien,[],dugg_street).
composite_road(dugnadsveien,[],dugnads_street).
composite_road(dunkers,[street],dunkers_street).
composite_road(dybwads,[street],dybwads_street).
composite_road(dyna,[brygge],dyna_brygge).
composite_road(dynekilgata,[],dynekil_street).
composite_road(dyretråkket,[],dyretråkket).
composite_road(dyrlandsveien,[],dyrlands_street).
composite_road(dyvekes,[street],dyvekes_street).
composite_road(dælenenggata,[],dæleneng_street).
composite_road(dølerudveien,[],dølerud_street).
composite_road(ebbells,[street],ebbells_street).
composite_road(eckersbergs,[street],eckersbergs_street).
composite_road(eddaveien,[],edda_street).
composite_road(edmund,[neuperts,street],edmund_neuperts_street).
composite_road(edvard,[griegs,alle],edvard_griegs_alle).
composite_road(edvard,[munchs,street],edvard_munchs_street).
composite_road(edvard,[storms,street],edvard_storms_street).
composite_road(eftasåsen,[],eftasåsen).
composite_road(egedes,[street],egedes_street).
composite_road(egnehjemveien,[],egnehjem_street).
composite_road(eikelundveien,[],eikelund_street).
composite_road(eikelundveien,[],eikelund_street).
composite_road(eikeveien,[],eike_street).
composite_road(eilert,[smiths,street],eilert_smiths_street).
composite_road(eilert,[sundts,street],eilert_sundts_street).
composite_road(einar,[gerhardsens,plass],einar_gerhardsens_plass).
composite_road(einar,[høigårds,street],einar_høigårds_street).
composite_road(einar,[skjæraasens,street],einar_skjæraasens_street).
composite_road(einars,[street],einars_street).
composite_road(eindrides,[street],eindrides_street).
composite_road(einerveien,[],einer_street).
composite_road(eirik,[raudes,street],eirik_raudes_street).
composite_road(eiriks,[street],eiriks_street).
composite_road(ekebergstien,[],ekebergstien).
composite_road(ekebergveien,[],ekeberg_street).
composite_road(ekebergveien,[],ekeberg_street).
composite_road(ekelyveien,[],ekely_street).
composite_road(ekornveien,[],ekorn_street).
composite_road(ekraveien,[],ekra_street).
composite_road(elgtråkket,[],elgtråkket).
composite_road(elgveien,[],elg_street).
composite_road(elias,[blix,street],elias_blix_street).
composite_road(elisenbergveien,[],elisenberg_street).
composite_road(ellen,[gleditsch,street],ellen_gleditsch_street).
composite_road(ellingsrudveien,[],ellingsrud_street).
composite_road(elmholt,[alle],elmholt_alle).
composite_road(elmholtveien,[],elmholt_street).
composite_road(elsters,[street],elsters_street).
composite_road(eltonveien,[],elton_street).
composite_road(elvefaret,[],elvefaret).
composite_road(elvefaret,[],elvefaret).
composite_road(elverumgata,[],elverum_street).
composite_road(emil,[korsmos,street],emil_korsmos_street).
composite_road(enebakkveien,[],enebakk_street).
composite_road(enebakkveien,[],enebakk_street).
composite_road(enebakkveien,[],enebakk_street).
composite_road(enebakkveien,[],enebakk_street).
composite_road(enebostubben,[],enebostubben).
composite_road(eneboveien,[],enebo_street).
composite_road(enerhauggata,[],enerhaug_street).
composite_road(enerhaugkleiva,[],enerhaugkleiva).
composite_road(enerhaugplassen,[],enerhaugplassen).
composite_road(engebrets,[street],engebrets_street).
composite_road(engebråtveien,[],engebråt_street).
composite_road(engveien,[],eng_street).
composite_road(enoks,[street],enoks_street).
composite_road(ensjøsvingen,[],ensjøsvingen).
composite_road(ensjøveien,[],ensjø_street).
composite_road(erich,[mogensøns,street],erich_mogensøns_street).
composite_road(erika,[nissens,street],erika_nissens_street).
composite_road(erlandstuveien,[],erlandstu_street).
composite_road(erlends,[street],erlends_street).
composite_road(erling,[michelsens,street],erling_michelsens_street).
composite_road(erling,[schiøtz,street],erling_schiøtz_street).
composite_road(erling,[skjalgssons,street],erling_skjalgssons_street).
composite_road(erlings,[street],erlings_street).
composite_road(essendrops,[street],essendrops_street).
composite_road(eterveien,[],eter_street).
composite_road(etterstadgata,[],etterstad_street).
composite_road(etterstadkroken,[],etterstadkroken).
composite_road(etterstadsletta,[],etterstadsletta).
composite_road(eugenies,[street],eugenies_street).
composite_road(eugene,[hanssens,street],eugene_hanssens_street).
composite_road(europarådets,[plass],europarådets_plass).
composite_road(evald,[ryghs,street],evald_ryghs_street).
composite_road(evens,[street],evens_street).
composite_road(eventyrveien,[],eventyr_street).
composite_road(eystein,[torkildsens,street],eystein_torkildsens_street).
composite_road(fabritiusalleen,[],fabritiusalleen).
composite_road(fagerborggata,[],fagerborg_street).
composite_road(fagerborggata,[],fagerborg_street).
composite_road(fagerheimgata,[],fagerheim_street).
composite_road(fagerheimgata,[],fagerheim_street).
composite_road(fagerlia,[],fagerlia).
composite_road(fagerliveien,[],fagerli_street).
composite_road(fagertunveien,[],fagertun_street).
composite_road(falbes,[street],falbes_street).
composite_road(fallanveien,[],fallan_street).
composite_road(falsens,[street],falsens_street).
composite_road(fastings,[street],fastings_street).
composite_road(fauchalds,[street],fauchalds_street).
composite_road(faunveien,[],faun_street).
composite_road(fayes,[street],fayes_street).
composite_road(fearnleys,[street],fearnleys_street).
composite_road(feddersens,[street],feddersens_street).
composite_road(feltspatveien,[],feltspat_street).
composite_road(fernanda,[nissens,street],fernanda_nissens_street).
composite_road(festningsplassen,[],festningsplassen).
composite_road(fetsundgata,[],fetsund_street).
composite_road(filerveien,[],filer_street).
composite_road(filips,[street],filips_street).
composite_road(filipstad,[brygge],filipstad_brygge).
composite_road(filipstadveien,[],filipstad_street).
composite_road(finnhaugveien,[],finnhaug_street).
composite_road(finnmarkgata,[],finnmark_street).
composite_road(finns,[street],finns_street).
composite_road(fiolveien,[],fiol_street).
composite_road(firkløverveien,[],firkløver_street).
composite_road(fiskekroken,[],fiskekroken).
composite_road(fisker,[syversens,street],fisker_syversens_street).
composite_road(fjeldhøikroken,[],fjeldhøikroken).
composite_road(fjellgata,[],fjell_street).
composite_road(fjellhus,[alle],fjellhus_alle).
composite_road(fjellhøiveien,[],fjellhøi_street).
composite_road(fjellklangveien,[],fjellklang_street).
composite_road(fjellknattveien,[],fjellknatt_street).
composite_road(fjellstien,[],fjellstien).
composite_road(fjellstuveien,[],fjellstu_street).
composite_road(fjordalleen,[],fjordalleen).
composite_road(fjordgløttveien,[],fjordgløtt_street).
composite_road(fjordveien,[],fjord_street).
composite_road(fjørtofts,[street],fjørtofts_street).
composite_road(flaengrenda,[],flaengrenda).
composite_road(flaenveien,[],flaen_street).
composite_road(flesåstunet,[],flesåstunet).
composite_road(flesåsveien,[],flesås_street).
composite_road(florabakken,[],florabakken).
composite_road(flyveien,[],fly_street).
composite_road(folke,[bernadottes,street],folke_bernadottes_street).
composite_road(folkvangveien,[],folkvang_street).
composite_road(formerveien,[],former_street).
composite_road(forskningsveien,[],forsknings_street).
composite_road(fossefaret,[],fossefaret).
composite_road(fossilveien,[],fossil_street).
composite_road(fossumberget,[],fossumberget).
composite_road(fossumkroken,[],fossumkroken).
composite_road(fossumveien,[],fossum_street).
composite_road(fossveien,[],foss_street).
composite_road(fougners,[street],fougners_street).
composite_road(fougstads,[street],fougstads_street).
composite_road(framnes,[terrasse],framnes_terrasse).
composite_road(framnesveien,[],framnes_street).
composite_road(framveien,[],fram_street).
composite_road(frantzebråtveien,[],frantzebråt_street).
composite_road(fred,[olsens,street],fred_olsens_street).
composite_road(fredensborgveien,[],fredensborg_street).
composite_road(fredensborgveien,[],fredensborg_street).
composite_road(frederik,[glads,street],frederik_glads_street).
composite_road(frederik,[haslunds,street],frederik_haslunds_street).
composite_road(frederik,[stangs,street],frederik_stangs_street).
composite_road(frederiks,[street],frederiks_street).
composite_road(fredheimveien,[],fredheim_street).
composite_road(fredrik,[selmers,street],fredrik_selmers_street).
composite_road(fredrikke,[qvams,street],fredrikke_qvams_street).
composite_road(fredriksborgveien,[],fredriksborg_street).
composite_road(fredveien,[],fred_street).
composite_road(freidigveien,[],freidig_street).
composite_road(frennings,[street],frennings_street).
composite_road(freserveien,[],freser_street).
composite_road(frichs,[street],frichs_street).
composite_road(fridtjof,[nansens,plass],fridtjof_nansens_plass).
composite_road(fridtjof,[nansens,street],fridtjof_nansens_street).
composite_road(fridtjof,[nansens,street],fridtjof_nansens_street).
composite_road(fridtjovs,[street],fridtjovs_street).
composite_road(frierveien,[],frier_street).
composite_road(friggs,[street],friggs_street).
composite_road(friis,[street],friis_street).
composite_road(frimanns,[street],frimanns_street).
composite_road(frits,[kiærs,street],frits_kiærs_street).
composite_road(fritzners,[street],fritzners_street).
composite_road(frodes,[street],frodes_street).
composite_road(frogner,[plass],frogner_plass).
composite_road(frogner,[terrasse],frogner_terrasse).
composite_road(frognerseterveien,[],frognerseter_street).
composite_road(frognerstranda,[],frognerstranda).
composite_road(frognerveien,[],frogner_street).
composite_road(frostveien,[],frost_street).
composite_road(frostveien,[],frost_street).
composite_road(fru,[kroghs,brygge],fru_kroghs_brygge).
composite_road(frydenbergbakken,[],frydenbergbakken).
composite_road(frydenbergveien,[],frydenberg_street).
composite_road(frydenlundgata,[],frydenlund_street).
composite_road(frydens,[street],frydens_street).
composite_road(frysjaveien,[],frysja_street).
composite_road(frøensalleen,[],frøensalleen).
composite_road(frølichs,[street],frølichs_street).
composite_road(frøyas,[street],frøyas_street).
composite_road(frøydis,[street],frøydis_street).
composite_road(fuglehauggata,[],fuglehaug_street).
composite_road(fugleliveien,[],fugleli_street).
composite_road(furer,[nymos,street],furer_nymos_street).
composite_road(furubråtveien,[],furubråt_street).
composite_road(furukollveien,[],furukoll_street).
composite_road(furulundsveien,[],furulunds_street).
composite_road(furulundtoppen,[],furulundtoppen).
composite_road(furumoen,[],furumoen).
composite_road(furuset,[alle],furuset_alle).
composite_road(furusetveien,[],furuset_street).
composite_road(furuveien,[],furu_street).
composite_road(fyrstikkalleen,[],fyrstikkalleen).
composite_road(fyrstikkbakken,[],fyrstikkbakken).
composite_road(fyrstikkbakken,[],fyrstikkbakken).
composite_road(fådveien,[],fåd_street).
composite_road(gabbi,[lunds,street],gabbi_lunds_street).
composite_road(gabels,[street],gabels_street).
composite_road(galgeberg,[],galgeberg).
composite_road(gamle,[brennavei],gamle_brenna_street).
composite_road(gamle,[bygdevei],gamle_bygde_street).
composite_road(gamle,[bygdevei],gamle_bygde_street).
composite_road(gamle,[enebakkvei],gamle_enebakk_street).
composite_road(gamle,[herregårdsvei],gamle_herregårds_street).
composite_road(gamle,[hovsetervei],gamle_hovseter_street).
composite_road(gamle,[kjelsåsvei],gamle_kjelsås_street).
composite_road(gamle,[leirdals,street],gamle_leirdals_street).
composite_road(gamle,[madserud,alle],gamle_madserud_alle).
composite_road(gamle,[maridalsvei],gamle_maridals_street).
composite_road(gamle,[strømsvei],gamle_strøms_street).
composite_road(gamle,[trondheimsveien],gamle_trondheims_street).
composite_road(gamlehagen,[],gamlehagen).
composite_road(gamlelinja,[],gamlelinja).
composite_road(gamleveien,[],gamle_street).
composite_road(gange,[rolvs,street],gange_rolvs_street).
composite_road(gangstuveien,[],gangstu_street).
composite_road(gardeveien,[],garde_street).
composite_road(gartnerveien,[],gartner_street).
composite_road(garver,[ytteborgs,street],garver_ytteborgs_street).
composite_road(gaupefaret,[],gaupefaret).
composite_road(gaustadalleen,[],gaustadalleen).
composite_road(gaustadalleen,[],gaustadalleen).
composite_road(gaustadveien,[],gaustad_street).
composite_road(geitmyrsveien,[],geitmyrs_street).
composite_road(general,[birchs,street],general_birchs_street).
composite_road(general,[krohgs,street],general_krohgs_street).
composite_road(general,[ruges,street],general_ruges_street).
composite_road(generallunden,[],generallunden).
composite_road(geologsvingen,[],geologsvingen).
composite_road(geviret,[],geviret).
composite_road(gildevangen,[],gildevangen).
composite_road(gimle,[terrasse],gimle_terrasse).
composite_road(gimleveien,[],gimle_street).
composite_road(gina,[krogs,street],gina_krogs_street).
composite_road(giskehagen,[],giskehagen).
composite_road(gisles,[street],gisles_street).
composite_road(gjennomfaret,[],gjennomfaret).
composite_road(gjerdesmutten,[],gjerdesmutten).
composite_road(gjerdrums,[street],gjerdrums_street).
composite_road(gjøaveien,[],gjøa_street).
composite_road(gjøkbakken,[],gjøkbakken).
composite_road(gjørstads,[street],gjørstads_street).
composite_road(gjøvikgata,[],gjøvik_street).
composite_road(glacisgata,[],glacis_street).
composite_road(gladengveien,[],gladeng_street).
composite_road(glads,[street],glads_street).
composite_road(gladvoll,[terrasse],gladvoll_terrasse).
composite_road(gladvollveien,[],gladvoll_street).
composite_road(glimmerveien,[],glimmer_street).
composite_road(glitreveien,[],glitre_street).
composite_road(gluckstads,[street],gluckstads_street).
composite_road(godals,[street],godals_street).
composite_road(godheimveien,[],godheim_street).
composite_road(godlia,[parksti],godlia_parksti).
composite_road(godliasvingen,[],godliasvingen).
composite_road(godliaveien,[],godlia_street).
composite_road(golfstubben,[],golfstubben).
composite_road(graahbakken,[],graahbakken).
composite_road(granbergstubben,[],granbergstubben).
composite_road(grandeveien,[],grande_street).
composite_road(granebakken,[],granebakken).
composite_road(granhekkveien,[],granhekk_street).
composite_road(granittveien,[],granitt_street).
composite_road(grankollveien,[],grankoll_street).
composite_road(grankvisten,[],grankvisten).
composite_road(granliveien,[],granli_street).
composite_road(gransdalen,[],gransdalen).
composite_road(gransdalen,[],gransdalen).
composite_road(granstangen,[],granstangen).
composite_road(granstangen,[],granstangen).
composite_road(granstuveien,[],granstu_street).
composite_road(grantunet,[],grantunet).
composite_road(granveien,[],gran_street).
composite_road(grasveien,[],gras_street).
composite_road(gravdalsveien,[],gravdals_street).
composite_road(grefsen,[alle],grefsen_alle).
composite_road(grefsenkollveien,[],grefsenkoll_street).
composite_road(grefsentunet,[],grefsentunet).
composite_road(grefsenveien,[],grefsen_street).
composite_road(grefsenveien,[],grefsen_street).
composite_road(gregers,[grams,street],gregers_grams_street).
composite_road(grensen,[],grensen).
composite_road(grensestien,[],grensestien).
composite_road(grensesvingen,[],grensesvingen).
composite_road(grenseveien,[],grense_street).
composite_road(grenseveien,[],grense_street).
composite_road(grev,[wedels,plass],grev_wedels_plass).
composite_road(greveveien,[],greve_street).
composite_road(grevlinglia,[],grevlinglia).
composite_road(grevlingveien,[],grevling_street).
composite_road(griffenfeldts,[street],griffenfeldts_street).
composite_road(grimelundshaugen,[],grimelundshaugen).
composite_road(grimelundsveien,[],grimelunds_street).
composite_road(grimstadgata,[],grimstad_street).
composite_road(grinda,[],grinda).
composite_road(grindbakken,[],grindbakken).
composite_road(griniveien,[],grini_street).
composite_road(grorudbakken,[],grorudbakken).
composite_road(grorudveien,[],grorud_street).
composite_road(grorudveien,[],grorud_street).
composite_road(grottenveien,[],grotten_street).
composite_road(grubbegata,[],grubbe_street).
composite_road(gruegata,[],grue_street).
composite_road(grundingen,[],grundingen).
composite_road(grusveien,[],grus_street).
composite_road(gruvelia,[],gruvelia).
composite_road(grytebekkveien,[],grytebekk_street).
composite_road(gryteveien,[],gryte_street).
composite_road(grønland,[],grønland).
composite_road(grønland,[],grønland).
composite_road(grønlandsleiret,[],grønlandsleiret).
composite_road(grønlibakken,[],grønlibakken).
composite_road(grønlikleiva,[],grønlikleiva).
composite_road(grønliveien,[],grønli_street).
composite_road(grønmoveien,[],grønmo_street).
composite_road(grønnegata,[],grønne_street).
composite_road(grønsundveien,[],grønsund_street).
composite_road(grønvoll,[alle],grønvoll_alle).
composite_road(gråbrødreveien,[],gråbrødre_street).
composite_road(grågåsveien,[],grågås_street).
composite_road(gråkamveien,[],gråkam_street).
composite_road(gråsteinveien,[],gråstein_street).
composite_road(gruners,[street],gruners_street).
composite_road(guldberglia,[],guldberglia).
composite_road(guldbergs,[street],guldbergs_street).
composite_road(gulleråsveien,[],gullerås_street).
composite_road(gullhaug,[torg],gullhaug_torg).
composite_road(gullhaugveien,[],gullhaug_street).
composite_road(gullkroken,[],gullkroken).
composite_road(gunnar,[johnsons,street],gunnar_johnsons_street).
composite_road(gunnar,[schjelderups,street],gunnar_schjelderups_street).
composite_road(gunnars,[street],gunnars_street).
composite_road(gunnulvs,[street],gunnulvs_street).
composite_road(gurinestubben,[],gurinestubben).
composite_road(guristuveien,[],guristu_street).
composite_road(gustav,[bloms,street],gustav_bloms_street).
composite_road(gustav,[heibergs,street],gustav_heibergs_street).
composite_road(gustav,[jensens,street],gustav_jensens_street).
composite_road(gustav,[vigelands,street],gustav_vigelands_street).
composite_road(gustavs,[street],gustavs_street).
composite_road(guvernørens,[street],guvernørens_street).
composite_road(gydas,[street],gydas_street).
composite_road(gyldenløves,[street],gyldenløves_street).
composite_road(gableins,[street],gableins_street).
composite_road(gørbitz,[street],gørbitz_street).
composite_road(gøteborggata,[],gøteborg_street).
composite_road(gårdsveien,[],gårds_street).
composite_road(haakon,[aunes,street],haakon_aunes_street).
composite_road(haakon,[den,godes,street],haakon_den_godes_street).
composite_road(haakon,[tveters,street],haakon_tveters_street).
composite_road(haakon,[viis,street],haakon_viis_street).
composite_road(haarklous,[plass],haarklous_plass).
composite_road(haavard,[martinsens,street],haavard_martinsens_street).
composite_road(hafrsfjordgata,[],hafrsfjord_street).
composite_road(hafslundveien,[],hafslund_street).
composite_road(hagaløkka,[],hagaløkka).
composite_road(hagan,[terrasse],hagan_terrasse).
composite_road(hagapynten,[],hagapynten).
composite_road(hagastubben,[],hagastubben).
composite_road(hagaveien,[],haga_street).
composite_road(hagegata,[],hage_street).
composite_road(hagelundveien,[],hagelund_street).
composite_road(hagtornveien,[],hagtorn_street).
composite_road(hakadalsveien,[],hakadals_street).
composite_road(hallagerbakken,[],hallagerbakken).
composite_road(hallings,[street],hallings_street).
composite_road(hallvard,[bergves,street],hallvard_bergves_street).
composite_road(halvdan,[svartes,street],halvdan_svartes_street).
composite_road(halvor,[blinderens,plass],halvor_blinderens_plass).
composite_road(halvor,[torgersens,street],halvor_torgersens_street).
composite_road(hamborgveien,[],hamborg_street).
composite_road(hammerfestgata,[],hammerfest_street).
composite_road(hammergata,[],hammer_street).
composite_road(hammersborg,[torg],hammersborg_torg).
composite_road(hammersborggata,[],hammersborg_street).
composite_road(hammerstads,[street],hammerstads_street).
composite_road(hans,[aanruds,street],hans_aanruds_street).
composite_road(hans,[barliens,street],hans_barliens_street).
composite_road(hans,[c,gjefles,street],hans_c_gjefles_street).
composite_road(hans,[møller,gasmanns,street],hans_møller_gasmanns_street).
composite_road(hans,[nielsen,hauges,street],hans_nielsen_hauges_street).
composite_road(hans,[nielsen,hauges,street],hans_nielsen_hauges_street).
composite_road(hans,[nielsen,hauges,plass],hans_nielsen_hauges_plass).
composite_road(hans,[nordahls,street],hans_nordahls_street).
composite_road(hans,[ross,street],hans_ross_street).
composite_road(hans,[steinpukkers,street],hans_steinpukkers_street).
composite_road(hansegata,[],hanse_street).
composite_road(hansemyrveien,[],hansemyr_street).
composite_road(hansteens,[street],hansteens_street).
composite_road(hanåveien,[],hanå_street).
composite_road(harald,[halvorsens,street],harald_halvorsens_street).
composite_road(harald,[hårfagres,street],harald_hårfagres_street).
composite_road(harald,[løvenskiolds,street],harald_løvenskiolds_street).
composite_road(harald,[rømckes,street],harald_rømckes_street).
composite_road(harald,[sohlbergs,street],harald_sohlbergs_street).
composite_road(haraldrudveien,[],haraldrud_street).
composite_road(haralds,[street],haralds_street).
composite_road(haraldsheimveien,[],haraldsheim_street).
composite_road(haraløkka,[],haraløkka).
composite_road(harbitzalleen,[],harbitzalleen).
composite_road(harestien,[],harestien).
composite_road(hareveien,[],hare_street).
composite_road(harry,[fetts,street],harry_fetts_street).
composite_road(hartmanns,[street],hartmanns_street).
composite_road(hartvig,[halvorsens,street],hartvig_halvorsens_street).
composite_road(haråsveien,[],harås_street).
composite_road(haslefetbakken,[],haslefetbakken).
composite_road(haslekroken,[],haslekroken).
composite_road(haslevangen,[],haslevangen).
composite_road(hasleveien,[],hasle_street).
composite_road(haslevollen,[],haslevollen).
composite_road(hasselbakken,[],hasselbakken).
composite_road(hasselhaugveien,[],hasselhaug_street).
composite_road(hauchs,[street],hauchs_street).
composite_road(haugakollveien,[],haugakoll_street).
composite_road(haugenstien,[],haugenstien).
composite_road(haugenstuveien,[],haugenstu_street).
composite_road(haugenstuveien,[],haugenstu_street).
composite_road(haugerudhagan,[],haugerudhagan).
composite_road(haugerudsenteret,[],haugerudsenteret).
composite_road(haugerudtunet,[],haugerudtunet).
composite_road(haugerudveien,[],haugerud_street).
composite_road(hauges,[street],hauges_street).
composite_road(haugmannsveien,[],haugmanns_street).
composite_road(haukelibakken,[],haukelibakken).
composite_road(hauketosvingen,[],hauketosvingen).
composite_road(hauketotoppen,[],hauketotoppen).
composite_road(hauketoveien,[],hauketo_street).
composite_road(hauketoåsen,[],hauketoåsen).
composite_road(hausmanns,[street],hausmanns_street).
composite_road(hausmanns,[street],hausmanns_street).
composite_road(havna,[alle],havna_alle).
composite_road(havnabakken,[],havnabakken).
composite_road(havnehagan,[],havnehagan).
composite_road(havreveien,[],havre_street).
composite_road(haxthausens,[street],haxthausens_street).
composite_road(hedmarksgata,[],hedmarks_street).
composite_road(hegdehaugsveien,[],hegdehaugs_street).
composite_road(hegermanns,[street],hegermanns_street).
composite_road(heggelibakken,[],heggelibakken).
composite_road(heggeliveien,[],heggeli_street).
composite_road(heiasvingen,[],heiasvingen).
composite_road(heierstuveien,[],heierstu_street).
composite_road(heimdalsgata,[],heimdals_street).
composite_road(heimdalsgata,[],heimdals_street).
composite_road(heimlibakken,[],heimlibakken).
composite_road(hekkveien,[],hekk_street).
composite_road(helga,[vaneks,street],helga_vaneks_street).
composite_road(helgesens,[street],helgesens_street).
composite_road(hellerud,[gårdsvei],hellerud_gårds_street).
composite_road(hellerud,[terrasse],hellerud_terrasse).
composite_road(hellerudfaret,[],hellerudfaret).
composite_road(hellerudgrenda,[],hellerudgrenda).
composite_road(hellerudstubben,[],hellerudstubben).
composite_road(hellerudsvingen,[],hellerudsvingen).
composite_road(hellerudveien,[],hellerud_street).
composite_road(hellerudveien,[],hellerud_street).
composite_road(helleveien,[],helle_street).
composite_road(hellinga,[],hellinga).
composite_road(hemingveien,[],heming_street).
composite_road(hemmestveitbakken,[],hemmest_streettbakken).
composite_road(hengsengveien,[],hengseng_street).
composite_road(henrichsens,[street],henrichsens_street).
composite_road(henrik,[backers,street],henrik_backers_street).
composite_road(henrik,[ibsens,street],henrik_ibsens_street).
composite_road(henrik,[ibsens,street],henrik_ibsens_street).
composite_road(henrik,[klausens,street],henrik_klausens_street).
composite_road(henrik,[mohns,plass],henrik_mohns_plass).
composite_road(henrik,[sørensens,street],henrik_sørensens_street).
composite_road(henriks,[street],henriks_street).
composite_road(herbernveien,[],herbern_street).
composite_road(herman,[foss,street],herman_foss_street).
composite_road(herregårdsveien,[],herregårds_street).
composite_road(herslebs,[street],herslebs_street).
composite_road(herslebs,[street],herslebs_street).
composite_road(hertug,[skules,street],hertug_skules_street).
composite_road(hertzbergs,[street],hertzbergs_street).
composite_road(hesjeveien,[],hesje_street).
composite_road(hesselbergs,[street],hesselbergs_street).
composite_road(hestehagen,[],hestehagen).
composite_road(hesteskoen,[],hesteskoen).
composite_road(heyerdahls,[street],heyerdahls_street).
composite_road(hieronymus,[heyerdahls,street],hieronymus_heyerdahls_street).
composite_road(hjalmar,[brantings,street],hjalmar_brantings_street).
composite_road(hjalmar,[brantings,street],hjalmar_brantings_street).
composite_road(hjalmar,[jordans,street],hjalmar_jordans_street).
composite_road(hjaltlandsgata,[],hjaltlands_street).
composite_road(hjelms,[street],hjelms_street).
composite_road(hjemliveien,[],hjemli_street).
composite_road(hjorteveien,[],hjorte_street).
composite_road(hjørungavåggata,[],hjørungavåg_street).
composite_road(hjørungkroken,[],hjørungkroken).
composite_road(hjørungveien,[],hjørung_street).
composite_road(hockeyveien,[],hockey_street).
composite_road(hoff,[terrasse],hoff_terrasse).
composite_road(hoffsbakken,[],hoffsbakken).
composite_road(hoffselvpromenaden,[],hoffselvpromenaden).
composite_road(hoffsjef,[løvenskiolds,street],hoffsjef_løvenskiolds_street).
composite_road(hoffsveien,[],hoffs_street).
composite_road(hofftunet,[],hofftunet).
composite_road(holbergs,[street],holbergs_street).
composite_road(holbergs,[street],holbergs_street).
composite_road(holbergs,[plass],holbergs_plass).
composite_road(holgerslystveien,[],holgerslyst_street).
composite_road(hollendergata,[],hollender_street).
composite_road(holmboes,[street],holmboes_street).
composite_road(holmendammen,[terrasse],holmendammen_terrasse).
composite_road(holmenenga,[],holmenenga).
composite_road(holmengrenda,[],holmengrenda).
composite_road(holmenhaugen,[],holmenhaugen).
composite_road(holmenkollveien,[],holmenkoll_street).
composite_road(holmens,[street],holmens_street).
composite_road(holmensletta,[],holmensletta).
composite_road(holmenveien,[],holmen_street).
composite_road(holmestrandgata,[],holmestrand_street).
composite_road(holmlia,[senter,street],holmlia_senter_street).
composite_road(holmliaveien,[],holmlia_street).
composite_road(holmliveien,[],holmli_street).
composite_road(holmsåsen,[],holmsåsen).
composite_road(holsteinveien,[],holstein_street).
composite_road(holsts,[street],holsts_street).
composite_road(holsts,[street],holsts_street).
composite_road(holtegata,[],holte_street).
composite_road(holtveien,[],holt_street).
composite_road(homansbakken,[],homansbakken).
composite_road(hoppveien,[],hopp_street).
composite_road(hornfjellveien,[],hornfjell_street).
composite_road(hortengata,[],horten_street).
composite_road(hospitsveien,[],hospits_street).
composite_road(hovfaret,[],hovfaret).
composite_road(hovinveien,[],hovin_street).
composite_road(hovseterveien,[],hovseter_street).
composite_road(hubroveien,[],hubro_street).
composite_road(huitfeldts,[street],huitfeldts_street).
composite_road(huk,[aveny],huk_aveny).
composite_road(huk,[terrasse],huk_terrasse).
composite_road(hukenveien,[],huken_street).
composite_road(hukgrenda,[],hukgrenda).
composite_road(huldreveien,[],huldre_street).
composite_road(humleveien,[],humle_street).
composite_road(hummerkloa,[],hummerkloa).
composite_road(hurdalsgata,[],hurdals_street).
composite_road(husebybakken,[],husebybakken).
composite_road(husebygrenda,[],husebygrenda).
composite_road(husebyveien,[],huseby_street).
composite_road(hyggeveien,[],hygge_street).
composite_road(hyllveien,[],hyll_street).
composite_road(høgdaveien,[],høgda_street).
composite_road(høgdefaret,[],høgdefaret).
composite_road(høgtunveien,[],høgtun_street).
composite_road(høgåsveien,[],høgås_street).
composite_road(hølandsgata,[],hølands_street).
composite_road(høyboveien,[],høybo_street).
composite_road(høybråtenstien,[],høybråtenstien).
composite_road(høybråtenveien,[],høybråten_street).
composite_road(høybråtenveien,[],høybråten_street).
composite_road(høydalsveien,[],høydals_street).
composite_road(høyenhall,[plass],høyenhall_plass).
composite_road(høyenhallsvingen,[],høyenhallsvingen).
composite_road(høyenhallveien,[],høyenhall_street).
composite_road(høyesteretts,[plass],høyesteretts_plass).
composite_road(håkons,[street],håkons_street).
composite_road(håvalds,[street],håvalds_street).
composite_road(idas,[street],idas_street).
composite_road(idrettsveien,[],idretts_street).
composite_road(iduns,[street],iduns_street).
composite_road(ilagata,[],ila_street).
composite_road(industrigata,[],industri_street).
composite_road(inga,[bjørnsons,street],inga_bjørnsons_street).
composite_road(ingar,[nilsens,street],ingar_nilsens_street).
composite_road(ingeborgs,[street],ingeborgs_street).
composite_road(ingebret,[andersens,street],ingebret_andersens_street).
composite_road(ingelbrecht,[knudssøns,street],ingelbrecht_knudssøns_street).
composite_road(ingeniørveien,[],ingeniør_street).
composite_road(inges,[street],inges_street).
composite_road(ingiers,[street],ingiers_street).
composite_road(ingolf,[ruuds,street],ingolf_ruuds_street).
composite_road(inkognito,[terrasse],inkognito_terrasse).
composite_road(inkognitogata,[],inkognito_street).
composite_road(innspurten,[],innspurten).
composite_road(irisveien,[],iris_street).
composite_road(islands,[street],islands_street).
composite_road(ivan,[bjørndals,street],ivan_bjørndals_street).
composite_road(ivar,[aasens,street],ivar_aasens_street).
composite_road(ivar,[knutsons,street],ivar_knutsons_street).
composite_road(ivar,[welles,street],ivar_welles_street).
composite_road(iver,[olsens,street],iver_olsens_street).
composite_road(jacob,[aalls,street],jacob_aalls_street).
composite_road(jacob,[aalls,street],jacob_aalls_street).
composite_road(jacob,[fayes,street],jacob_fayes_street).
composite_road(jacob,[hansens,street],jacob_hansens_street).
composite_road(jacobine,[ryes,street],jacobine_ryes_street).
composite_road(jansbergveien,[],jansberg_street).
composite_road(jarbakken,[],jarbakken).
composite_road(jarlegata,[],jarle_street).
composite_road(jarlsborgveien,[],jarlsborg_street).
composite_road(jegerveien,[],jeger_street).
composite_road(jens,[bjelkes,street],jens_bjelkes_street).
composite_road(jens,[bjelkes,street],jens_bjelkes_street).
composite_road(jensmessveien,[],jensmess_street).
composite_road(jeppes,[street],jeppes_street).
composite_road(jerikoveien,[],jeriko_street).
composite_road(jernbanetorget,[],jernbanetorget).
composite_road(jernbaneveien,[],jernbane_street).
composite_road(jernkroken,[],jernkroken).
composite_road(jernkroken,[],jernkroken).
composite_road(jerpefaret,[],jerpefaret).
composite_road(jess,[carlsens,street],jess_carlsens_street).
composite_road(jetteveien,[],jette_street).
composite_road(joh,[h,andresens,street],joh_h_andresens_street).
composite_road(johan,[castbergs,street],johan_castbergs_street).
composite_road(johan,[evjes,street],johan_evjes_street).
composite_road(johan,[hirsch,street],johan_hirsch_street).
composite_road(johan,[scharffenbergs,street],johan_scharffenbergs_street).
composite_road(johan,[selmers,street],johan_selmers_street).
composite_road(johan,[svendsens,street],johan_svendsens_street).
composite_road(johan,[sverdrups,street],johan_sverdrups_street).
composite_road(johan,[throne,holsts,plass],johan_throne_holsts_plass).
composite_road(johanne,[dybwads,plass],johanne_dybwads_plass).
composite_road(johannes,[bruns,street],johannes_bruns_street).
composite_road(john,[brandts,street],john_brandts_street).
composite_road(john,[colletts,alle],john_colletts_alle).
composite_road(john,[g,mattesons,street],john_g_mattesons_street).
composite_road(johnny,[svorkmos,street],johnny_svorkmos_street).
composite_road(jolly,[kramer,johansens,street],jolly_kramer_johansens_street).
composite_road(jomfrubråtveien,[],jomfrubråt_street).
composite_road(jomfruhagen,[],jomfruhagen).
composite_road(jomfrustien,[],jomfrustien).
composite_road(jon,[p,erliens,street],jon_p_erliens_street).
composite_road(jon,[smestads,street],jon_smestads_street).
composite_road(jonas,[dahls,street],jonas_dahls_street).
composite_road(jonas,[reins,street],jonas_reins_street).
composite_road(jonsokveien,[],jonsok_street).
composite_road(jonsrudveien,[],jonsrud_street).
composite_road(jordal,[terrasse],jordal_terrasse).
composite_road(jordalgata,[],jordal_street).
composite_road(jordbærveien,[],jordbær_street).
composite_road(jordstjerneveien,[],jordstjerne_street).
composite_road(jorines,[street],jorines_street).
composite_road(josefines,[street],josefines_street).
composite_road(jotunveien,[],jotun_street).
composite_road(jupiterveien,[],jupiter_street).
composite_road(jutulveien,[],jutul_street).
composite_road(jutulveien,[],jutul_street).
composite_road(jøranstien,[],jøranstien).
composite_road(jørgen,[løvlands,street],jørgen_løvlands_street).
composite_road(jørgen,[moes,street],jørgen_moes_street).
composite_road(jørnsløkkveien,[],jørnsløkk_street).
composite_road(kaare,[røddes,plass],kaare_røddes_plass).
composite_road(kabelgaten,[],kabel_streetn).
composite_road(kaiekroken,[],kaiekroken).
composite_road(kaj,[munks,street],kaj_munks_street).
composite_road(kakkelovnskroken,[],kakkelovnskroken).
composite_road(kalbakkfaret,[],kalbakkfaret).
composite_road(kalbakkslyngen,[],kalbakkslyngen).
composite_road(kalbakkstubben,[],kalbakkstubben).
composite_road(kalbakkveien,[],kalbakk_street).
composite_road(kallandveien,[],kalland_street).
composite_road(kallerudveien,[],kallerud_street).
composite_road(kampen,[hageby],kampen_hageby).
composite_road(kampengata,[],kampen_street).
composite_road(kampheimveien,[],kampheim_street).
composite_road(kanalen,[],kanalen).
composite_road(kanonhallveien,[],kanonhall_street).
composite_road(kanslergata,[],kansler_street).
composite_road(kantarellen,[terrasse],kantarellen_terrasse).
composite_road(kapellveien,[],kapell_street).
composite_road(kaptein,[oppegaards,street],kaptein_oppegaards_street).
composite_road(karen,[platous,street],karen_platous_street).
composite_road(karenslyst,[alle],karenslyst_alle).
composite_road(karihaugveien,[],karihaug_street).
composite_road(karistuveien,[],karistu_street).
composite_road(karl,[andersens,street],karl_andersens_street).
composite_road(karl,[flods,street],karl_flods_street).
composite_road(karl,[fossums,street],karl_fossums_street).
composite_road(karl,[johans,street],karl_johans_street).
composite_road(karl,[staaffs,street],karl_staaffs_street).
composite_road(karlsborgveien,[],karlsborg_street).
composite_road(karlsrudveien,[],karlsrud_street).
composite_road(karlstadgata,[],karlstad_street).
composite_road(karoline,[kristiansens,street],karoline_kristiansens_street).
composite_road(karolinerveien,[],karoliner_street).
composite_road(karsten,[kjelbergs,street],karsten_kjelbergs_street).
composite_road(kasaveien,[],kasa_street).
composite_road(kastanjeveien,[],kastanje_street).
composite_road(kastellbakken,[],kastellbakken).
composite_road(kastellhagen,[],kastellhagen).
composite_road(kastellveien,[],kastell_street).
composite_road(katy,[dues,street],katy_dues_street).
composite_road(kavringen,[brygge],kavringen_brygge).
composite_road(keysers,[street],keysers_street).
composite_road(kierschows,[street],kierschows_street).
composite_road(kierschows,[street],kierschows_street).
composite_road(kikkutveien,[],kikkut_street).
composite_road(kildals,[street],kildals_street).
composite_road(kildeveien,[],kilde_street).
composite_road(killingen,[],killingen).
composite_road(kingos,[street],kingos_street).
composite_road(kirkebakken,[],kirkebakken).
composite_road(kirkegata,[],kirke_street).
composite_road(kirkegårdsbakken,[],kirkegårdsbakken).
composite_road(kirkegårdsgata,[],kirkegårds_street).
composite_road(kirkehaugsveien,[],kirkehaugs_street).
composite_road(kirkesvingen,[],kirkesvingen).
composite_road(kirkeveien,[],kirke_street).
composite_road(kirkeveien,[],kirke_street).
composite_road(kirkeåsveien,[],kirkeås_street).
composite_road(kirsten,[flagstads,plass],kirsten_flagstads_plass).
composite_road(kittel,[nielsens,street],kittel_nielsens_street).
composite_road(kjeld,[stubs,street],kjeld_stubs_street).
composite_road(kjelsåsløkka,[],kjelsåsløkka).
composite_road(kjelsåsveien,[],kjelsås_street).
composite_road(kjetils,[street],kjetils_street).
composite_road(kjølberggata,[],kjølberg_street).
composite_road(klaus,[torgårds,street],klaus_torgårds_street).
composite_road(kleiva,[],kleiva).
composite_road(klemetsrudveien,[],klemetsrud_street).
composite_road(klingenberggata,[],klingenberg_street).
composite_road(klinkerveien,[],klinker_street).
composite_road(klostergata,[],kloster_street).
composite_road(klosterheimveien,[],klosterheim_street).
composite_road(kløfterhagen,[],kløfterhagen).
composite_road(kløverveien,[],kløver_street).
composite_road(kneika,[],kneika).
composite_road(knud,[bryns,street],knud_bryns_street).
composite_road(knud,[graahs,street],knud_graahs_street).
composite_road(knud,[øyens,street],knud_øyens_street).
composite_road(knut,[alvssons,street],knut_alvssons_street).
composite_road(knut,[valstads,street],knut_valstads_street).
composite_road(kobbernaglen,[],kobbernaglen).
composite_road(kolderups,[street],kolderups_street).
composite_road(kollstien,[],kollstien).
composite_road(kolonihagestien,[],kolonihagestien).
composite_road(kolstadgata,[],kolstad_street).
composite_road(kommandør,[t,i,øgrims,plass],kommandør_t_i_øgrims_plass).
composite_road(kongens,[street],kongens_street).
composite_road(kongeveien,[],konge_street).
composite_road(konghellegata,[],konghelle_street).
composite_road(konglerudtoppen,[],konglerudtoppen).
composite_road(kongleveien,[],kongle_street).
composite_road(kongsberggata,[],kongsberg_street).
composite_road(kongshavnveien,[],kongshavn_street).
composite_road(kongsstien,[],kongsstien).
composite_road(kongsveien,[],kongs_street).
composite_road(kongsveien,[],kongs_street).
composite_road(kongsvingergata,[],kongsvinger_street).
composite_road(konows,[street],konows_street).
composite_road(konsul,[schjelderups,street],konsul_schjelderups_street).
composite_road(konvallveien,[],konvall_street).
composite_road(konventveien,[],konvent_street).
composite_road(kopperuds,[street],kopperuds_street).
composite_road(korallveien,[],korall_street).
composite_road(korsgata,[],kors_street).
composite_road(korsvoll,[terrasse],korsvoll_terrasse).
composite_road(korsvollbakken,[],korsvollbakken).
composite_road(korsvollbråtan,[],korsvollbråtan).
composite_road(krafts,[street],krafts_street).
composite_road(krags,[terrasse],krags_terrasse).
composite_road(krags,[street],krags_street).
composite_road(kragstubben,[],kragstubben).
composite_road(kransen,[],kransen).
composite_road(kranveien,[],kran_street).
composite_road(krebs,[street],krebs_street).
composite_road(kringkollen,[],kringkollen).
composite_road(kringlebekkveien,[],kringlebekk_street).
composite_road(kringsjågrenda,[],kringsjågrenda).
composite_road(kringveien,[],kring_street).
composite_road(kristian,[auberts,street],kristian_auberts_street).
composite_road(kristian,[augusts,street],kristian_augusts_street).
composite_road(kristian,[bogneruds,street],kristian_bogneruds_street).
composite_road(kristian,[ivs,street],kristian_ivs_street).
composite_road(kristianiasvingen,[],kristianiasvingen).
composite_road(kristiansands,[street],kristiansands_street).
composite_road(kristine,[bonnevies,street],kristine_bonnevies_street).
composite_road(kristinelundveien,[],kristinelund_street).
composite_road(kristins,[street],kristins_street).
composite_road(kristoffer,[aamots,street],kristoffer_aamots_street).
composite_road(kristoffer,[robins,street],kristoffer_robins_street).
composite_road(kroken,[],kroken).
composite_road(krokkleiva,[],krokkleiva).
composite_road(krokliveien,[],krokli_street).
composite_road(krokstien,[],krokstien).
composite_road(krokusveien,[],krokus_street).
composite_road(kronprinsens,[street],kronprinsens_street).
composite_road(kronprinsens,[street],kronprinsens_street).
composite_road(kronprinsesse,[marthas,plass],kronprinsesse_marthas_plass).
composite_road(kronveien,[],kron_street).
composite_road(krossveien,[],kross_street).
composite_road(krumgata,[],krum_street).
composite_road(kruses,[street],kruses_street).
composite_road(kruttveien,[],krutt_street).
composite_road(kryssveien,[],kryss_street).
composite_road(kudalsveien,[],kudals_street).
composite_road(kurlandstien,[],kurlandstien).
composite_road(kurveien,[],kur_street).
composite_road(kvartsveien,[],kvarts_street).
composite_road(kvernfaret,[],kvernfaret).
composite_road(kvernkallveien,[],kvernkall_street).
composite_road(kvernstien,[],kvernstien).
composite_road(kvernveien,[],kvern_street).
composite_road(kvistveien,[],kvist_street).
composite_road(kværnerveien,[],kværner_street).
composite_road(kyhns,[street],kyhns_street).
composite_road(kyrre,[grepps,street],kyrre_grepps_street).
composite_road(københavngata,[],københavn_street).
composite_road(kåres,[street],kåres_street).
composite_road(lachmanns,[street],lachmanns_street).
composite_road(ladeveien,[],lade_street).
composite_road(lakkegata,[],lakke_street).
composite_road(lakkegata,[],lakke_street).
composite_road(lallakroken,[],lallakroken).
composite_road(lambertseterveien,[],lambertseter_street).
composite_road(lambertseterveien,[],lambertseter_street).
composite_road(lammers,[street],lammers_street).
composite_road(landerokollen,[],landerokollen).
composite_road(landeroveien,[],landero_street).
composite_road(landgangen,[],landgangen).
composite_road(landingsveien,[],landings_street).
composite_road(landstads,[street],landstads_street).
composite_road(langaards,[street],langaards_street).
composite_road(langbølgen,[],langbølgen).
composite_road(langengen,[],langengen).
composite_road(langerudhaugen,[],langerudhaugen).
composite_road(langerudsvingen,[],langerudsvingen).
composite_road(langerudveien,[],langerud_street).
composite_road(langes,[street],langes_street).
composite_road(langgata,[],lang_street).
composite_road(langkaia,[],langkaia).
composite_road(langlia,[],langlia).
composite_road(langlibakken,[],langlibakken).
composite_road(langmyrgrenda,[],langmyrgrenda).
composite_road(langmyrveien,[],langmyr_street).
composite_road(langretta,[],langretta).
composite_road(langs,[linjen],langs_linjen).
composite_road(langsetveien,[],langset_street).
composite_road(langteigåsen,[],langteigåsen).
composite_road(langviksveien,[],langviks_street).
composite_road(langåsveien,[],langås_street).
composite_road(larsbråtveien,[],larsbråt_street).
composite_road(larviksgata,[],larviks_street).
composite_road(lassons,[street],lassons_street).
composite_road(laura,[gundersens,street],laura_gundersens_street).
composite_road(lauvlundveien,[],lauvlund_street).
composite_road(lavrans,[street],lavrans_street).
composite_road(leirfallsgata,[],leirfalls_street).
composite_road(leirskallbakken,[],leirskallbakken).
composite_road(leirskallen,[],leirskallen).
composite_road(leirskallhellinga,[],leirskallhellinga).
composite_road(leirskallsvingen,[],leirskallsvingen).
composite_road(leiv,[eirikssons,street],leiv_eirikssons_street).
composite_road(lekeplassveien,[],lekeplass_street).
composite_road(lensmann,[hiorths,alle],lensmann_hiorths_alle).
composite_road(lerdalsfaret,[],lerdalsfaret).
composite_road(lerdalsgrenda,[],lerdalsgrenda).
composite_road(lerdalstoppen,[],lerdalstoppen).
composite_road(lerdalsveien,[],lerdals_street).
composite_road(lerkeveien,[],lerke_street).
composite_road(lersolveien,[],lersol_street).
composite_road(lettvintveien,[],lettvint_street).
composite_road(leyrins,[street],leyrins_street).
composite_road(liakollveien,[],liakoll_street).
composite_road(liaveien,[],lia_street).
composite_road(libakkfaret,[],libakkfaret).
composite_road(libakkveien,[],libakk_street).
composite_road(liljeveien,[],lilje_street).
composite_road(lille,[bislett],lille_bislett).
composite_road(lille,[borgen,street],lille_borgen_street).
composite_road(lille,[frogner,alle],lille_frogner_alle).
composite_road(lille,[frøens,street],lille_frøens_street).
composite_road(lille,[grensen],lille_grensen).
composite_road(lille,[huseby,street],lille_huseby_street).
composite_road(lille,[stensrud],lille_stensrud).
composite_road(lille,[stranden],lille_stranden).
composite_road(lilleakerveien,[],lilleaker_street).
composite_road(lillebakken,[],lillebakken).
composite_road(lillebergsvingen,[],lillebergsvingen).
composite_road(lillebergveien,[],lilleberg_street).
composite_road(lilleborggata,[],lilleborg_street).
composite_road(lilletorget,[],lilletorget).
composite_road(lillevannsskogen,[],lillevannsskogen).
composite_road(lillevannsveien,[],lillevanns_street).
composite_road(lilleveien,[],lille_street).
composite_road(lilloe,[olsens,street],lilloe_olsens_street).
composite_road(lillogata,[],lillo_street).
composite_road(lilloseterveien,[],lilloseter_street).
composite_road(lindbackveien,[],lindback_street).
composite_road(lindealleen,[],lindealleen).
composite_road(lindeberglia,[],lindeberglia).
composite_road(lindebergveien,[],lindeberg_street).
composite_road(lindebergåsen,[],lindebergåsen).
composite_road(lindemans,[street],lindemans_street).
composite_road(linderngata,[],lindern_street).
composite_road(linderudsletta,[],linderudsletta).
composite_road(linderudveien,[],linderud_street).
composite_road(lindøya,[],lindøya).
composite_road(linhusveien,[],linhus_street).
composite_road(linjebakken,[],linjebakken).
composite_road(linjeveien,[],linje_street).
composite_road(linneaveien,[],linnea_street).
composite_road(linstows,[street],linstows_street).
composite_road(ljabrubakken,[],ljabrubakken).
composite_road(ljabrukollen,[terrasse],ljabrukollen_terrasse).
composite_road(ljabruveien,[],ljabru_street).
composite_road(ljabruveien,[],ljabru_street).
composite_road(ljan,[terrasse],ljan_terrasse).
composite_road(ljansbakken,[],ljansbakken).
composite_road(ljansbrukveien,[],ljansbruk_street).
composite_road(lofotgata,[],lofot_street).
composite_road(lofsrudhøgda,[],lofsrudhøgda).
composite_road(lofsrudveien,[],lofsrud_street).
composite_road(lofthus,[terrasse],lofthus_terrasse).
composite_road(lofthusveien,[],lofthus_street).
composite_road(lofthusveien,[],lofthus_street).
composite_road(lokkeberget,[],lokkeberget).
composite_road(louises,[street],louises_street).
composite_road(lovisenberggata,[],lovisenberg_street).
composite_road(lovisenlund,[],lovisenlund).
composite_road(ludvig,[karstens,street],ludvig_karstens_street).
composite_road(luftfartsveien,[],luftfarts_street).
composite_road(lunaveien,[],luna_street).
composite_road(lunden,[],lunden).
composite_road(lundliveien,[],lundli_street).
composite_road(lundveien,[],lund_street).
composite_road(lundåsveien,[],lundås_street).
composite_road(lunnestien,[],lunnestien).
composite_road(lusetjernveien,[],lusetjern_street).
composite_road(lutvannskroken,[],lutvannskroken).
composite_road(lutvannsveien,[],lutvanns_street).
composite_road(lybekkergata,[],lybekker_street).
composite_road(lybekkveien,[],lybekk_street).
composite_road(lyberget,[],lyberget).
composite_road(lyder,[sagens,street],lyder_sagens_street).
composite_road(lyngtrekket,[],lyngtrekket).
composite_road(lyngveien,[],lyng_street).
composite_road(lyngåsveien,[],lyngås_street).
composite_road(lysebuveien,[],lysebu_street).
composite_road(lysehagan,[],lysehagan).
composite_road(lyseskrenten,[],lyseskrenten).
composite_road(lyseveien,[],lyse_street).
composite_road(lyveien,[],ly_street).
composite_road(lærer,[holes,street],lærer_holes_street).
composite_road(løchenveien,[],løchen_street).
composite_road(løkkalia,[],løkkalia).
composite_road(løkkaskogen,[],løkkaskogen).
composite_road(løkkegangen,[],løkkegangen).
composite_road(løkkeveien,[],løkke_street).
composite_road(lønneveien,[],lønne_street).
composite_road(lønnhaugen,[alle],lønnhaugen_alle).
composite_road(lørenfaret,[],lørenfaret).
composite_road(lørenvangen,[],lørenvangen).
composite_road(lørenveien,[],løren_street).
composite_road(løvenskiolds,[street],løvenskiolds_street).
composite_road(løvsetdalen,[],løvsetdalen).
composite_road(løvsetfaret,[],løvsetfaret).
composite_road(løvåsveien,[],løvås_street).
composite_road(løypeveien,[],løype_street).
composite_road(låveveien,[],låve_street).
composite_road(madame,[maren,juels,street],madame_maren_juels_street).
composite_road(madserud,[alle],madserud_alle).
composite_road(magnefaret,[],magnefaret).
composite_road(magnus,[barfots,street],magnus_barfots_street).
composite_road(magnus,[bergs,street],magnus_bergs_street).
composite_road(magnus,[hydles,street],magnus_hydles_street).
composite_road(magnus,[street],magnus_street).
composite_road(mailundveien,[],mailund_street).
composite_road(majorstuveien,[],majorstu_street).
composite_road(malerhaugveien,[],malerhaug_street).
composite_road(malmøgata,[],malmø_street).
composite_road(malmøyveien,[],malmøy_street).
composite_road(mandalls,[street],mandalls_street).
composite_road(manglebergveien,[],mangleberg_street).
composite_road(manglerudveien,[],manglerud_street).
composite_road(marcus,[thranes,street],marcus_thranes_street).
composite_road(margit,[hansens,street],margit_hansens_street).
composite_road(margrethe,[parms,street],margrethe_parms_street).
composite_road(maria,[dehlis,street],maria_dehlis_street).
composite_road(mariboes,[street],mariboes_street).
composite_road(maridalsveien,[],maridals_street).
composite_road(maridalsveien,[],maridals_street).
composite_road(maridalsveien,[],maridals_street).
composite_road(maridalsveien,[],maridals_street).
composite_road(marienlundveien,[],marienlund_street).
composite_road(maries,[street],maries_street).
composite_road(mariholtveien,[],mariholt_street).
composite_road(markstien,[],markstien).
composite_road(markveien,[],mark_street).
composite_road(marmorveien,[],marmor_street).
composite_road(marselis,[street],marselis_street).
composite_road(marstrandgata,[],marstrand_street).
composite_road(marsveien,[],mars_street).
composite_road(marta,[steinsviks,street],marta_steinsviks_street).
composite_road(martha,[tynes,street],martha_tynes_street).
composite_road(martin,[borrebekkens,street],martin_borrebekkens_street).
composite_road(martin,[linges,street],martin_linges_street).
composite_road(martin,[skatvedts,street],martin_skatvedts_street).
composite_road(martin,[strandlis,street],martin_strandlis_street).
composite_road(mastrups,[street],mastrups_street).
composite_road(mauritz,[hansens,street],mauritz_hansens_street).
composite_road(maurstien,[],maurstien).
composite_road(maurtuveien,[],maurtu_street).
composite_road(mekanikerveien,[],mekaniker_street).
composite_road(meklenborglia,[],meklenborglia).
composite_road(meklenborgveien,[],meklenborg_street).
composite_road(meklenborgåsen,[],meklenborgåsen).
composite_road(melkeveien,[],melke_street).
composite_road(mellbyedalen,[],mellbyedalen).
composite_road(mellombølgen,[],mellombølgen).
composite_road(meltzers,[street],meltzers_street).
composite_road(melumveien,[],melum_street).
composite_road(merkurveien,[],merkur_street).
composite_road(messepromenaden,[],messepromenaden).
composite_road(michel,[nielsens,street],michel_nielsens_street).
composite_road(micheletveien,[],michelet_street).
composite_road(middelthuns,[street],middelthuns_street).
composite_road(midtoddveien,[],midtodd_street).
composite_road(midtstugrenda,[],midtstugrenda).
composite_road(midttunveien,[],midttun_street).
composite_road(midtveien,[],midt_street).
composite_road(midtåsen,[],midtåsen).
composite_road(mikael,[hertzbergs,street],mikael_hertzbergs_street).
composite_road(mikjelsbakken,[],mikjelsbakken).
composite_road(mikkel,[doblougs,street],mikkel_doblougs_street).
composite_road(mikkel,[revs,street],mikkel_revs_street).
composite_road(mikrobølgen,[],mikrobølgen).
composite_road(mina,[beiteplukksvei],mina_beiteplukks_street).
composite_road(minister,[ditleffs,street],minister_ditleffs_street).
composite_road(minåsveien,[],minås_street).
composite_road(mogata,[],mo_street).
composite_road(mogens,[thorsens,street],mogens_thorsens_street).
composite_road(moldegata,[],molde_street).
composite_road(moltke,[moes,street],moltke_moes_street).
composite_road(monolitveien,[],monolit_street).
composite_road(monrads,[street],monrads_street).
composite_road(monrads,[street],monrads_street).
composite_road(montebello,[terrasse],montebello_terrasse).
composite_road(montebellobakken,[],montebellobakken).
composite_road(montebelloveien,[],montebello_street).
composite_road(mor,[gohjertas,street],mor_gohjertas_street).
composite_road(morells,[street],morells_street).
composite_road(morenestien,[],morenestien).
composite_road(morgedalsvegen,[],morgedals_street).
composite_road(morgedalsvegen,[],morgedals_street).
composite_road(mortensrudveien,[],mortensrud_street).
composite_road(mortensvingen,[],mortensvingen).
composite_road(mosekollen,[],mosekollen).
composite_road(moserabben,[],moserabben).
composite_road(mosseveien,[],mosse_street).
composite_road(mosseveien,[],mosse_street).
composite_road(mosseveien,[],mosse_street).
composite_road(motbakkene,[],motbakkene).
composite_road(motzfeldts,[street],motzfeldts_street).
composite_road(movassbakken,[],movassbakken).
composite_road(munchs,[street],munchs_street).
composite_road(munkebekken,[],munkebekken).
composite_road(munkedamsveien,[],munkedams_street).
composite_road(munkedamsveien,[],munkedams_street).
composite_road(munkegata,[],munke_street).
composite_road(munkelia,[],munkelia).
composite_road(munkengveien,[],munkeng_street).
composite_road(munkerudbakken,[],munkerudbakken).
composite_road(munkerudkleiva,[],munkerudkleiva).
composite_road(munkerudstubben,[],munkerudstubben).
composite_road(munkerudtunet,[],munkerudtunet).
composite_road(munkerudveien,[],munkerud_street).
composite_road(munkerudveien,[],munkerud_street).
composite_road(munkerudvollen,[],munkerudvollen).
composite_road(munkerudåsen,[],munkerudåsen).
composite_road(munthes,[street],munthes_street).
composite_road(muselundgrenda,[],muselundgrenda).
composite_road(museumsveien,[],museums_street).
composite_road(mustads,[street],mustads_street).
composite_road(myklegardgata,[],myklegard_street).
composite_road(mylskerudveien,[],mylskerud_street).
composite_road(myntfunnveien,[],myntfunn_street).
composite_road(myntgata,[],mynt_street).
composite_road(myrbakkveien,[],myrbakk_street).
composite_road(myrdalveien,[],myrdal_street).
composite_road(myrerdraget,[],myrerdraget).
composite_road(myrerskogveien,[],myrerskog_street).
composite_road(myrerveien,[],myrer_street).
composite_road(myrhaugen,[],myrhaugen).
composite_road(mælosvingen,[],mælosvingen).
composite_road(møllefaret,[],møllefaret).
composite_road(møllefaret,[],møllefaret).
composite_road(mølleparken,[],mølleparken).
composite_road(møllergata,[],møller_street).
composite_road(møllerveien,[],møller_street).
composite_road(møllesvingen,[],møllesvingen).
composite_road(måkeveien,[],måke_street).
composite_road(måltrostveien,[],måltrost_street).
composite_road(mårveien,[],mår_street).
composite_road(nandrups,[street],nandrups_street).
composite_road(nannestadgata,[],nannestad_street).
composite_road(nebbejordet,[],nebbejordet).
composite_road(nedre,[street],nedre_street).
composite_road(nedre,[kalbakkvei],nedre_kalbakk_street).
composite_road(nedre,[kalbakkvei],nedre_kalbakk_street).
composite_road(nedre,[prinsdals,street],nedre_prinsdals_street).
composite_road(nedre,[rommen],nedre_rommen).
composite_road(nedre,[silkestrå],nedre_silkestrå).
composite_road(nedre,[skogvei],nedre_skog_street).
composite_road(nedre,[skøyen,street],nedre_skøyen_street).
composite_road(nedre,[slottsgate],nedre_slotts_street).
composite_road(nedre,[stabburvei],nedre_stabbur_street).
composite_road(nedre,[ullern,terrasse],nedre_ullern_terrasse).
composite_road(nedre,[ullevål],nedre_ullevål).
composite_road(nedre,[vaskegang],nedre_vaskegang).
composite_road(nedre,[vollgate],nedre_voll_street).
composite_road(nedslagsveien,[],nedslags_street).
composite_road(nellikveien,[],nellik_street).
composite_road(neptunveien,[],neptun_street).
composite_road(neuberggata,[],neuberg_street).
composite_road(nico,[hambros,street],nico_hambros_street).
composite_road(niels,[henrik,abels,street],niels_henrik_abels_street).
composite_road(niels,[juels,street],niels_juels_street).
composite_road(nielsenbakken,[],nielsenbakken).
composite_road(nils,[bays,street],nils_bays_street).
composite_road(nils,[collett,vogts,street],nils_collett_vogts_street).
composite_road(nils,[hansens,street],nils_hansens_street).
composite_road(nils,[huus,street],nils_huus_street).
composite_road(nils,[lauritssøns,street],nils_lauritssøns_street).
composite_road(nils,[tollers,street],nils_tollers_street).
composite_road(nilserudkleiva,[],nilserudkleiva).
composite_road(nissens,[street],nissens_street).
composite_road(nittedalgata,[],nittedal_street).
composite_road(njåls,[street],njåls_street).
composite_road(nobels,[street],nobels_street).
composite_road(nonnegata,[],nonne_street).
composite_road(norbygata,[],norby_street).
composite_road(nordahl,[bruns,street],nordahl_bruns_street).
composite_road(nordalveien,[],nordal_street).
composite_road(nordbergbakken,[],nordbergbakken).
composite_road(nordbergveien,[],nordberg_street).
composite_road(nordengstubben,[],nordengstubben).
composite_road(nordengveien,[],nordeng_street).
composite_road(norderhovgata,[],norderhov_street).
composite_road(nordhagaveien,[],nordhaga_street).
composite_road(nordheimbakken,[],nordheimbakken).
composite_road(nordkappgata,[],nordkapp_street).
composite_road(nordlandsgata,[],nordlands_street).
composite_road(nordlisletta,[],nordlisletta).
composite_road(nordlisvingen,[],nordlisvingen).
composite_road(nordlitoppen,[],nordlitoppen).
composite_road(nordliveien,[],nordli_street).
composite_road(nordlysveien,[],nordlys_street).
composite_road(nordmarka,[],nordmarka).
composite_road(nordmarka,[],nordmarka).
composite_road(nordmarkveien,[],nordmark_street).
composite_road(nordmørgata,[],nordmør_street).
composite_road(nordraaks,[street],nordraaks_street).
composite_road(nordre,[dals,street],nordre_dals_street).
composite_road(nordre,[street],nordre_street).
composite_road(nordseter,[terrasse],nordseter_terrasse).
composite_road(nordsetergrenda,[],nordsetergrenda).
composite_road(nordseterstien,[],nordseterstien).
composite_road(nordseterveien,[],nordseter_street).
composite_road(nordstjerneveien,[],nordstjerne_street).
composite_road(nordstrand,[terrasse],nordstrand_terrasse).
composite_road(nordstrandveien,[],nordstrand_street).
composite_road(nordtvetbakken,[],nordtvetbakken).
composite_road(nordtvetveien,[],nordtvet_street).
composite_road(nordåssløyfa,[],nordåssløyfa).
composite_road(nordåsveien,[],nordås_street).
composite_road(noreveien,[],nore_street).
composite_road(normannsgata,[],normanns_street).
composite_road(nuggerudveien,[],nuggerud_street).
composite_road(nybrottveien,[],nybrott_street).
composite_road(nybyggerveien,[],nybygger_street).
composite_road(nycoveien,[],nyco_street).
composite_road(nydalen,[alle],nydalen_alle).
composite_road(nydalen,[alle],nydalen_alle).
composite_road(nydalen,[bruks,street],nydalen_bruks_street).
composite_road(nydalsveien,[],nydals_street).
composite_road(nygata,[],ny_street).
composite_road(nygård,[terrasse],nygård_terrasse).
composite_road(nygårds,[alle],nygårds_alle).
composite_road(nygårdsveien,[],nygårds_street).
composite_road(nyjordeveien,[],nyjorde_street).
composite_road(nyjordstubben,[],nyjordstubben).
composite_road(nylandsveien,[],nylands_street).
composite_road(nylænde,[],nylænde).
composite_road(nypeveien,[],nype_street).
composite_road(nyquistveien,[],nyquist_street).
composite_road(nøklesvingen,[],nøklesvingen).
composite_road(nøklevannsveien,[],nøklevanns_street).
composite_road(nøkleveien,[],nøkle_street).
composite_road(nøttekneika,[],nøttekneika).
composite_road(nøtteveien,[],nøtte_street).
composite_road(nåkkves,[street],nåkkves_street).
composite_road(oberst,[angells,street],oberst_angells_street).
composite_road(oberst,[rodes,street],oberst_rodes_street).
composite_road(observatorie,[terrasse],observatorie_terrasse).
composite_road(observatoriegata,[],observatorie_street).
composite_road(odalsgata,[],odals_street).
composite_road(odd,[hassels,street],odd_hassels_street).
composite_road(odins,[street],odins_street).
composite_road(odvar,[solbergs,street],odvar_solbergs_street).
composite_road(ogmunds,[street],ogmunds_street).
composite_road(ola,[narr],ola_narr).
composite_road(olaf,[bulls,street],olaf_bulls_street).
composite_road(olaf,[helsets,street],olaf_helsets_street).
composite_road(olaf,[lørenskogens,street],olaf_lørenskogens_street).
composite_road(olaf,[ryes,plass],olaf_ryes_plass).
composite_road(olaf,[schous,street],olaf_schous_street).
composite_road(olafiagangen,[],olafiagangen).
composite_road(olasrudveien,[],olasrud_street).
composite_road(olaus,[fjørtofts,street],olaus_fjørtofts_street).
composite_road(olav,[aukrusts,street],olav_aukrusts_street).
composite_road(olav,[hegnas,street],olav_hegnas_street).
composite_road(olav,[kyrres,street],olav_kyrres_street).
composite_road(olav,[kyrres,plass],olav_kyrres_plass).
composite_road(olav,[m,troviks,street],olav_m_troviks_street).
composite_road(olav,[nygards,street],olav_nygards_street).
composite_road(olav,[selvaags,plass],olav_selvaags_plass).
composite_road(olav,[vs,street],olav_vs_street).
composite_road(olaves,[hvervens,street],olaves_hvervens_street).
composite_road(ole,[brumms,street],ole_brumms_street).
composite_road(ole,[bulls,street],ole_bulls_street).
composite_road(ole,[deviks,street],ole_deviks_street).
composite_road(ole,[fladagers,street],ole_fladagers_street).
composite_road(ole,[jacob,brochs,street],ole_jacob_brochs_street).
composite_road(ole,[messelts,street],ole_messelts_street).
composite_road(ole,[moes,street],ole_moes_street).
composite_road(ole,[reistads,street],ole_reistads_street).
composite_road(ole,[vigs,street],ole_vigs_street).
composite_road(ole,[wingers,street],ole_wingers_street).
composite_road(olleveien,[],olle_street).
composite_road(olsens,[enkes,street],olsens_enkes_street).
composite_road(oluf,[onsums,street],oluf_onsums_street).
composite_road(oluf,[ryghs,street],oluf_ryghs_street).
composite_road(ombergveien,[],omberg_street).
composite_road(omsens,[street],omsens_street).
composite_road(oppegårdgata,[],oppegård_street).
composite_road(opplandgata,[],oppland_street).
composite_road(oppsal,[terrasse],oppsal_terrasse).
composite_road(oppsalstubben,[],oppsalstubben).
composite_road(oppsaltoppen,[],oppsaltoppen).
composite_road(oppsalveien,[],oppsal_street).
composite_road(oreliveien,[],oreli_street).
composite_road(orionveien,[],orion_street).
composite_road(orknøygata,[],orknøy_street).
composite_road(ormsundbakken,[],ormsundbakken).
composite_road(ormsundveien,[],ormsund_street).
composite_road(ormøybakken,[],ormøybakken).
composite_road(orrebakken,[],orrebakken).
composite_road(orreskogen,[],orreskogen).
composite_road(orreveien,[],orre_street).
composite_road(oscar,[dahls,street],oscar_dahls_street).
composite_road(oscars,[street],oscars_street).
composite_road(oscarshallveien,[],oscarshall_street).
composite_road(oskar,[braatens,street],oskar_braatens_street).
composite_road(oskar,[braatens,plass],oskar_braatens_plass).
composite_road(oslo,[street],oslo_street).
composite_road(ostadalsveien,[],ostadals_street).
composite_road(osterhaus,[street],osterhaus_street).
composite_road(othilie,[tonnings,street],othilie_tonnings_street).
composite_road(ottar,[birtings,street],ottar_birtings_street).
composite_road(otto,[blehrs,street],otto_blehrs_street).
composite_road(otto,[sogns,street],otto_sogns_street).
composite_road(ove,[kristiansens,street],ove_kristiansens_street).
composite_road(p,[a,holms,street],p_a_holms_street).
composite_road(p,[a,munchs,street],p_a_munchs_street).
composite_road(p,[t,mallings,street],p_t_mallings_street).
composite_road(paal,[bergs,street],paal_bergs_street).
composite_road(pans,[street],pans_street).
composite_road(pareliusveien,[],parelius_street).
composite_road(parkdammen,[],parkdammen).
composite_road(parkenga,[],parkenga).
composite_road(parkveien,[],park_street).
composite_road(pasoplia,[],pasoplia).
composite_road(pasopsvingen,[],pasopsvingen).
composite_road(pasopveien,[],pasop_street).
composite_road(pastor,[blaauws,street],pastor_blaauws_street).
composite_road(pastor,[fangens,street],pastor_fangens_street).
composite_road(paulus,[plass],paulus_plass).
composite_road(pavels,[street],pavels_street).
composite_road(pearl,[engens,street],pearl_engens_street).
composite_road(peder,[ankers,street],peder_ankers_street).
composite_road(peder,[claussøns,street],peder_claussøns_street).
composite_road(peder,[grøns,street],peder_grøns_street).
composite_road(peder,[holters,street],peder_holters_street).
composite_road(per,[gynts,street],per_gynts_street).
composite_road(per,[krohgs,street],per_krohgs_street).
composite_road(per,[kvibergs,street],per_kvibergs_street).
composite_road(pernilles,[street],pernilles_street).
composite_road(persbråtan,[],persbråtan).
composite_road(persveien,[],pers_street).
composite_road(peter,[aas,street],peter_aas_street).
composite_road(peter,[møllers,street],peter_møllers_street).
composite_road(pilestredet,[],pilestredet).
composite_road(pilestredet,[],pilestredet).
composite_road(pilestredet,[park],pilestredet_park).
composite_road(pilotveien,[],pilot_street).
composite_road(pilveien,[],pil_street).
composite_road(pionerstien,[],pionerstien).
composite_road(planetveien,[],planet_street).
composite_road(platous,[street],platous_street).
composite_road(platåveien,[],platå_street).
composite_road(plogveien,[],plog_street).
composite_road(pløens,[street],pløens_street).
composite_road(pontoppidans,[street],pontoppidans_street).
composite_road(poppelstien,[],poppelstien).
composite_road(porfyrveien,[],porfyr_street).
composite_road(postdamveien,[],postdam_street).
composite_road(pottemakerveien,[],pottemaker_street).
composite_road(president,[harbitz,street],president_harbitz_street).
composite_road(presidentgata,[],president_street).
composite_road(prestegata,[],preste_street).
composite_road(prestegårdsveien,[],prestegårds_street).
composite_road(prestlia,[],prestlia).
composite_road(prinsdalsfaret,[],prinsdalsfaret).
composite_road(prinsdalskleiva,[],prinsdalskleiva).
composite_road(prinsens,[street],prinsens_street).
composite_road(prinsessealleen,[],prinsessealleen).
composite_road(priorveien,[],prior_street).
composite_road(problemveien,[],problem_street).
composite_road(professor,[aschehougs,plass],professor_aschehougs_plass).
composite_road(professor,[birkelands,street],professor_birkelands_street).
composite_road(professor,[dahls,street],professor_dahls_street).
composite_road(professor,[lochmanns,street],professor_lochmanns_street).
composite_road(promenaden,[],promenaden).
composite_road(prost,[hallings,street],prost_hallings_street).
composite_road(protonveien,[],proton_street).
composite_road(rabakken,[],rabakken).
composite_road(rabbeveien,[],rabbe_street).
composite_road(radarveien,[],radar_street).
composite_road(radioveien,[],radio_street).
composite_road(ragna,[maries,street],ragna_maries_street).
composite_road(ragna,[nielsens,street],ragna_nielsens_street).
composite_road(ragnfrids,[street],ragnfrids_street).
composite_road(ragnhild,[schibbyes,street],ragnhild_schibbyes_street).
composite_road(ranunkelveien,[],ranunkel_street).
composite_road(rappveien,[],rapp_street).
composite_road(raschs,[street],raschs_street).
composite_road(rasmus,[engers,street],rasmus_engers_street).
composite_road(rasmus,[winderens,street],rasmus_winderens_street).
composite_road(rasmusbakken,[],rasmusbakken).
composite_road(rathkes,[street],rathkes_street).
composite_road(raukveien,[],rauk_street).
composite_road(ravnkollbakken,[],ravnkollbakken).
composite_road(ravnkroken,[],ravnkroken).
composite_road(ravnåsveien,[],ravnås_street).
composite_road(refstad,[alle],refstad_alle).
composite_road(refstadsvingen,[],refstadsvingen).
composite_road(refstadveien,[],refstad_street).
composite_road(regnbueveien,[],regnbue_street).
composite_road(reichweins,[street],reichweins_street).
composite_road(reidar,[kobros,street],reidar_kobros_street).
composite_road(rektorhaugen,[],rektorhaugen).
composite_road(revefaret,[],revefaret).
composite_road(revierstredet,[],revierstredet).
composite_road(ribbunggata,[],ribbung_street).
composite_road(ribstonveien,[],ribston_street).
composite_road(riddervolds,[street],riddervolds_street).
composite_road(riflegata,[],rifle_street).
composite_road(rimveien,[],rim_street).
composite_road(ringgata,[],ring_street).
composite_road(ringnesveien,[],ringnes_street).
composite_road(ringshusstubben,[],ringshusstubben).
composite_road(ringshusveien,[],ringshus_street).
composite_road(ris,[skolevei],ris_skole_street).
composite_road(risalleen,[],risalleen).
composite_road(risbakken,[],risbakken).
composite_road(risbekkveien,[],risbekk_street).
composite_road(risløkkalleen,[],risløkkalleen).
composite_road(risløkkfaret,[],risløkkfaret).
composite_road(risløkkveien,[],risløkk_street).
composite_road(risstubben,[],risstubben).
composite_road(risveien,[],ris_street).
composite_road(roald,[amundsens,street],roald_amundsens_street).
composite_road(robert,[millars,street],robert_millars_street).
composite_road(rognerudveien,[],rognerud_street).
composite_road(rolf,[e,stenersens,alle],rolf_e_stenersens_alle).
composite_road(rolf,[hofmos,street],rolf_hofmos_street).
composite_road(rolf,[strangers,plass],rolf_strangers_plass).
composite_road(rolf,[wickstrøms,street],rolf_wickstrøms_street).
composite_road(rommibakken,[],rommibakken).
composite_road(rommiskogen,[],rommiskogen).
composite_road(romsdalsgata,[],romsdals_street).
composite_road(romsås,[senter],romsås_senter).
composite_road(romsåsveien,[],romsås_street).
composite_road(rosenbergveien,[],rosenberg_street).
composite_road(rosenborggata,[],rosenborg_street).
composite_road(rosendalsveien,[],rosendals_street).
composite_road(rosenhoffgata,[],rosenhoff_street).
composite_road(rosenholmveien,[],rosenholm_street).
composite_road(rosenkrantz,[street],rosenkrantz_street).
composite_road(rosenlundgata,[],rosenlund_street).
composite_road(roseveien,[],rose_street).
composite_road(rosings,[street],rosings_street).
composite_road(rosteds,[street],rosteds_street).
composite_road(rosteds,[street],rosteds_street).
composite_road(rostockgata,[],rostock_street).
composite_road(roveruds,[street],roveruds_street).
composite_road(rubina,[ranas,street],rubina_ranas_street).
composite_road(rugdeberget,[],rugdeberget).
composite_road(rugdestien,[],rugdestien).
composite_road(rugdeveien,[],rugde_street).
composite_road(rugveien,[],rug_street).
composite_road(rundhaugveien,[],rundhaug_street).
composite_road(rundingen,[],rundingen).
composite_road(rundmyrveien,[],rundmyr_street).
composite_road(rundtjernveien,[],rundtjern_street).
composite_road(ruseløkkveien,[],ruseløkk_street).
composite_road(ruseløkkveien,[],ruseløkk_street).
composite_road(rustadgrenda,[],rustadgrenda).
composite_road(rustadsaga,[],rustadsaga).
composite_road(ruths,[street],ruths_street).
composite_road(ryenbergveien,[],ryenberg_street).
composite_road(ryenbergveien,[],ryenberg_street).
composite_road(ryenstubben,[],ryenstubben).
composite_road(ryensvingen,[],ryensvingen).
composite_road(ryghs,[street],ryghs_street).
composite_road(røa,[terrasse],røa_terrasse).
composite_road(røahagan,[],røahagan).
composite_road(røahellinga,[],røahellinga).
composite_road(røaknekken,[],røaknekken).
composite_road(røatoppen,[],røatoppen).
composite_road(røaveien,[],røa_street).
composite_road(rødbergveien,[],rødberg_street).
composite_road(rødbråtbakken,[],rødbråtbakken).
composite_road(rødkleivfaret,[],rødkleivfaret).
composite_road(rødstuveien,[],rødstu_street).
composite_road(rødtvetkroken,[],rødtvetkroken).
composite_road(rødtvetveien,[],rødtvet_street).
composite_road(røhrts,[street],røhrts_street).
composite_road(rønningveien,[],rønning_street).
composite_road(røslyngveien,[],røslyng_street).
composite_road(rådhusbrygge,[1],rådhusbrygge_1).
composite_road(rådhusbrygge,[2],rådhusbrygge_2).
composite_road(rådhusbrygge,[3],rådhusbrygge_3).
composite_road(rådhusbrygge,[4],rådhusbrygge_4).
composite_road(rådhusgata,[],rådhus_street).
composite_road(rådhusplassen,[],rådhusplassen).
composite_road(rådyrlia,[],rådyrlia).
composite_road(rådyrstien,[],rådyrstien).
composite_road(rådyrveien,[],rådyr_street).
composite_road(juni,[plassen],juni_plassen).
composite_road(s,[h,lundhs,street],s_h_lundhs_street).
composite_road(sagadammen,[],sagadammen).
composite_road(sagstukroken,[],sagstukroken).
composite_road(sagstuveien,[],sagstu_street).
composite_road(sagveien,[],sag_street).
composite_road(sakariasveien,[],sakarias_street).
composite_road(salmakersvenn,[marius,jantzens,plass],salmakersvenn_marius_jantzens_plass).
composite_road(samvirkeveien,[],samvirke_street).
composite_road(sanatoriebakken,[],sanatoriebakken).
composite_road(sandakerveien,[],sandaker_street).
composite_road(sandakerveien,[],sandaker_street).
composite_road(sandefjordgata,[],sandefjord_street).
composite_road(sandermosveien,[],sandermos_street).
composite_road(sandstuveien,[],sandstu_street).
composite_road(sandstuveien,[],sandstu_street).
composite_road(sandtakveien,[],sandtak_street).
composite_road(sandåsveien,[],sandås_street).
composite_road(sannergata,[],sanner_street).
composite_road(sannergata,[],sanner_street).
composite_road(sarabråtveien,[],sarabråt_street).
composite_road(sarpsborggata,[],sarpsborg_street).
composite_road(sars,[street],sars_street).
composite_road(saturnveien,[],saturn_street).
composite_road(saxegaardsgata,[],saxegaards_street).
composite_road(schandorffs,[street],schandorffs_street).
composite_road(schives,[street],schives_street).
composite_road(schiøtts,[street],schiøtts_street).
composite_road(schleppegrells,[street],schleppegrells_street).
composite_road(schous,[plass],schous_plass).
composite_road(schouterrassen,[],schouterrassen).
composite_road(schultz,[street],schultz_street).
composite_road(schwachs,[street],schwachs_street).
composite_road(schweigaards,[street],schweigaards_street).
composite_road(schweigaards,[street],schweigaards_street).
composite_road(schwensens,[street],schwensens_street).
composite_road(schæffers,[street],schæffers_street).
composite_road(schønings,[street],schønings_street).
composite_road(schubelers,[street],schubelers_street).
composite_road(sehesteds,[street],sehesteds_street).
composite_road(seilduksgata,[],seilduks_street).
composite_road(seljeveien,[],selje_street).
composite_road(selvbyggerveien,[],selvbygger_street).
composite_road(sem,[sælands,street],sem_sælands_street).
composite_road(seterbråtveien,[],seterbråt_street).
composite_road(seterhøybakken,[],seterhøybakken).
composite_road(seterhøyveien,[],seterhøy_street).
composite_road(seterliveien,[],seterli_street).
composite_road(seterveien,[],seter_street).
composite_road(setervollveien,[],setervoll_street).
composite_road(setra,[street],setra_street).
composite_road(sexes,[street],sexes_street).
composite_road(sidsel,[sidsærks,street],sidsel_sidsærks_street).
composite_road(siebkes,[street],siebkes_street).
composite_road(sigbjørn,[obstfelders,street],sigbjørn_obstfelders_street).
composite_road(siggerudveien,[],siggerud_street).
composite_road(sigrid,[undsets,street],sigrid_undsets_street).
composite_road(sigurd,[a,danielsens,street],sigurd_a_danielsens_street).
composite_road(sigurd,[hoels,street],sigurd_hoels_street).
composite_road(sigurd,[iversens,street],sigurd_iversens_street).
composite_road(sigurd,[johannesens,street],sigurd_johannesens_street).
composite_road(sigurd,[lies,street],sigurd_lies_street).
composite_road(sigurd,[syrs,street],sigurd_syrs_street).
composite_road(sigurd,[weisæths,street],sigurd_weisæths_street).
composite_road(sigurds,[street],sigurds_street).
composite_road(sigyns,[street],sigyns_street).
composite_road(siloveien,[],silo_street).
composite_road(silurveien,[],silur_street).
composite_road(simensbrekka,[],simensbrekka).
composite_road(simensbråtveien,[],simensbråt_street).
composite_road(simon,[darres,street],simon_darres_street).
composite_road(singasteinveien,[],singastein_street).
composite_road(sinsenterrassen,[],sinsenterrassen).
composite_road(sinsenveien,[],sinsen_street).
composite_road(sinsenveien,[],sinsen_street).
composite_road(siriusveien,[],sirius_street).
composite_road(sisikveien,[],sisik_street).
composite_road(sjursøya,[],sjursøya).
composite_road(sjøgangen,[],sjøgangen).
composite_road(sjøgata,[],sjø_street).
composite_road(sjølyst,[plass],sjølyst_plass).
composite_road(skabos,[street],skabos_street).
composite_road(skansen,[terrasse],skansen_terrasse).
composite_road(skanseveien,[],skanse_street).
composite_road(skappels,[street],skappels_street).
composite_road(skarpsnogata,[],skarpsno_street).
composite_road(skarskroken,[],skarskroken).
composite_road(skausnaret,[],skausnaret).
composite_road(skedsmogata,[],skedsmo_street).
composite_road(skibakkeveien,[],skibakke_street).
composite_road(skiferveien,[],skifer_street).
composite_road(skigardveien,[],skigard_street).
composite_road(skillebekk,[],skillebekk).
composite_road(skinnerbakken,[],skinnerbakken).
composite_road(skippergata,[],skipper_street).
composite_road(skjelderups,[street],skjelderups_street).
composite_road(skjellveien,[],skjell_street).
composite_road(skjerstadveien,[],skjerstad_street).
composite_road(skjoldveien,[],skjold_street).
composite_road(skjønnhaugveien,[],skjønnhaug_street).
composite_road(skogbakken,[],skogbakken).
composite_road(skogbrynet,[],skogbrynet).
composite_road(skogfaret,[],skogfaret).
composite_road(skogholtveien,[],skogholt_street).
composite_road(skogroveien,[],skogro_street).
composite_road(skogryggveien,[],skogrygg_street).
composite_road(skogstien,[],skogstien).
composite_road(skogvollveien,[],skogvoll_street).
composite_road(skolebakken,[],skolebakken).
composite_road(skolestien,[],skolestien).
composite_road(skoleveien,[],skole_street).
composite_road(skovveien,[],skov_street).
composite_road(skrabben,[],skrabben).
composite_road(skrenten,[],skrenten).
composite_road(skullerudbakken,[],skullerudbakken).
composite_road(skullerudskogen,[],skullerudskogen).
composite_road(skullerudstubben,[],skullerudstubben).
composite_road(skullerudveien,[],skullerud_street).
composite_road(skuronnveien,[],skuronn_street).
composite_road(skøyen,[alle],skøyen_alle).
composite_road(skøyen,[terrasse],skøyen_terrasse).
composite_road(skøyenbakken,[],skøyenbakken).
composite_road(skøyenbrynet,[],skøyenbrynet).
composite_road(skøyenkneika,[],skøyenkneika).
composite_road(skøyenkroken,[],skøyenkroken).
composite_road(skøyenstubben,[],skøyenstubben).
composite_road(skøyensvingen,[],skøyensvingen).
composite_road(skøyenveien,[],skøyen_street).
composite_road(skøyenåsveien,[],skøyenås_street).
composite_road(skådalsveien,[],skådals_street).
composite_road(slalåmveien,[],slalåm_street).
composite_road(slemdalsveien,[],slemdals_street).
composite_road(slemdalsveien,[],slemdals_street).
composite_road(slemdalsvingen,[],slemdalsvingen).
composite_road(sletteløkka,[],sletteløkka).
composite_road(slettenveien,[],sletten_street).
composite_road(slimeveien,[],slime_street).
composite_road(slireveien,[],slire_street).
composite_road(sloreåsen,[],sloreåsen).
composite_road(sloreåsen,[],sloreåsen).
composite_road(slottsplassen,[],slottsplassen).
composite_road(slyngveien,[],slyng_street).
composite_road(slåmotgangen,[],slåmotgangen).
composite_road(slåtteveien,[],slåtte_street).
composite_road(smalgangen,[],smalgangen).
composite_road(smalvollveien,[],smalvoll_street).
composite_road(smalåkeren,[],smalåkeren).
composite_road(smed,[kjeldsens,street],smed_kjeldsens_street).
composite_road(smedbergveien,[],smedberg_street).
composite_road(smedgata,[],smed_street).
composite_road(smedhaugen,[],smedhaugen).
composite_road(smedstusvingen,[],smedstusvingen).
composite_road(smedveien,[],smed_street).
composite_road(smeltedigelen,[],smeltedigelen).
composite_road(smestadhagan,[],smestadhagan).
composite_road(smestadveien,[],smestad_street).
composite_road(smithsvingen,[],smithsvingen).
composite_road(smiuveien,[],smiu_street).
composite_road(smålensgata,[],smålens_street).
composite_road(snargangen,[],snargangen).
composite_road(snipemyrlia,[],snipemyrlia).
composite_road(snipemyrveien,[],snipemyr_street).
composite_road(snipp,[møllers,street],snipp_møllers_street).
composite_road(snippen,[],snippen).
composite_road(snorres,[street],snorres_street).
composite_road(snøggveien,[],snøgg_street).
composite_road(soelvolds,[street],soelvolds_street).
composite_road(sofienberggata,[],sofienberg_street).
composite_road(sofies,[street],sofies_street).
composite_road(sofies,[plass],sofies_plass).
composite_road(sognsvannsveien,[],sognsvanns_street).
composite_road(sognsvannsveien,[],sognsvanns_street).
composite_road(sognsveien,[],sogns_street).
composite_road(sognsveien,[],sogns_street).
composite_road(solbakken,[alle],solbakken_alle).
composite_road(solbakkeveien,[],solbakke_street).
composite_road(solbergliveien,[],solbergli_street).
composite_road(solefallsveien,[],solefalls_street).
composite_road(soleglad,[],soleglad).
composite_road(solemskogen,[],solemskogen).
composite_road(solemskogveien,[],solemskog_street).
composite_road(solfjellsbakken,[],solfjellsbakken).
composite_road(solfjellshøgda,[],solfjellshøgda).
composite_road(solhauggata,[],solhaug_street).
composite_road(solheimgata,[],solheim_street).
composite_road(solkroken,[],solkroken).
composite_road(sollerudveien,[],sollerud_street).
composite_road(solligata,[],solli_street).
composite_road(solligrenda,[],solligrenda).
composite_road(solskinnskroken,[],solskinnskroken).
composite_road(solskinnsveien,[],solskinns_street).
composite_road(solstugrenda,[],solstugrenda).
composite_road(solvangveien,[],solvang_street).
composite_road(solveien,[],sol_street).
composite_road(solørgata,[],solør_street).
composite_road(solåsveien,[],solås_street).
composite_road(sommerrogata,[],sommerro_street).
composite_road(sondrevegen,[],sondre_street).
composite_road(sonja,[henies,plass],sonja_henies_plass).
composite_road(sons,[street],sons_street).
composite_road(sophus,[aars,street],sophus_aars_street).
composite_road(sophus,[lies,street],sophus_lies_street).
composite_road(sorgenfrigata,[],sorgenfri_street).
composite_road(spektrumveien,[],spektrum_street).
composite_road(spikerveien,[],spiker_street).
composite_road(spiralen,[],spiralen).
composite_road(spireaveien,[],spirea_street).
composite_road(sponhoggbakken,[],sponhoggbakken).
composite_road(sponhoggveien,[],sponhogg_street).
composite_road(sponstugrenda,[],sponstugrenda).
composite_road(sponstuveien,[],sponstu_street).
composite_road(sportsstien,[],sportsstien).
composite_road(sportsveien,[],sports_street).
composite_road(sporveisgata,[],spor_streets_street).
composite_road(sporveisgata,[],spor_streets_street).
composite_road(spångbergveien,[],spångberg_street).
composite_road(st,[edmunds,street],st_edmunds_street).
composite_road(st,[georgs,street],st_georgs_street).
composite_road(st,[halvards,street],st_halvards_street).
composite_road(st,[halvards,plass],st_halvards_plass).
composite_road(st,[jørgens,street],st_jørgens_street).
composite_road(st,[olavs,street],st_olavs_street).
composite_road(st,[olavs,plass],st_olavs_plass).
composite_road(staffeldts,[street],staffeldts_street).
composite_road(stallerudveien,[],stallerud_street).
composite_road(stamhusveien,[],stamhus_street).
composite_road(stanseveien,[],stanse_street).
composite_road(starveien,[],star_street).
composite_road(stasjonsveien,[],stasjons_street).
composite_road(statsråd,[mathiesens,street],statsråd_mathiesens_street).
composite_road(staudeveien,[],staude_street).
composite_road(stavangergata,[],stavanger_street).
composite_road(steenstrups,[street],steenstrups_street).
composite_road(steinbakken,[],steinbakken).
composite_road(steinborgveien,[],steinborg_street).
composite_road(steingardveien,[],steingard_street).
composite_road(steingrims,[street],steingrims_street).
composite_road(steinhammerveien,[],steinhammer_street).
composite_road(steinliveien,[],steinli_street).
composite_road(steinspranget,[],steinspranget).
composite_road(stenbråtveien,[],stenbråt_street).
composite_road(stenbråtveien,[],stenbråt_street).
composite_road(stenersgata,[],steners_street).
composite_road(stensberggata,[],stensberg_street).
composite_road(stensgata,[],stens_street).
composite_road(stensrudlia,[],stensrudlia).
composite_road(stensrudsvingen,[],stensrudsvingen).
composite_road(stensrudåsveien,[],stensrudås_street).
composite_road(stiftamtmann,[kaas,street],stiftamtmann_kaas_street).
composite_road(stigenga,[],stigenga).
composite_road(stjerneblokkveien,[],stjerneblokk_street).
composite_road(stjernemyrveien,[],stjernemyr_street).
composite_road(stjerneveien,[],stjerne_street).
composite_road(stockfleths,[street],stockfleths_street).
composite_road(stockholmgata,[],stockholm_street).
composite_road(stolmakergata,[],stolmaker_street).
composite_road(stordamsnaret,[],stordamsnaret).
composite_road(stordamveien,[],stordam_street).
composite_road(stordamveien,[],stordam_street).
composite_road(storgata,[],stor_street).
composite_road(storgata,[],stor_street).
composite_road(storkenebbveien,[],storkenebb_street).
composite_road(stormyrveien,[],stormyr_street).
composite_road(storoveien,[],storo_street).
composite_road(stortingsgata,[],stortings_street).
composite_road(stortorvet,[],stortorvet).
composite_road(storåssvingen,[],storåssvingen).
composite_road(storåsveien,[],storås_street).
composite_road(stovner,[senter],stovner_senter).
composite_road(stovnerbakken,[],stovnerbakken).
composite_road(stovnerfaret,[],stovnerfaret).
composite_road(stovnerlia,[],stovnerlia).
composite_road(stovnerveien,[],stovner_street).
composite_road(stranden,[],stranden).
composite_road(strandgata,[],strand_street).
composite_road(strandhaugen,[],strandhaugen).
composite_road(strandpromenaden,[],strandpromenaden).
composite_road(strømsborgveien,[],strømsborg_street).
composite_road(strømstadgata,[],strømstad_street).
composite_road(strømsveien,[],strøms_street).
composite_road(strømsveien,[],strøms_street).
composite_road(stubberudveien,[],stubberud_street).
composite_road(sturlas,[street],sturlas_street).
composite_road(stuttvegen,[],stutt_street).
composite_road(stølsvegen,[],støls_street).
composite_road(støperigata,[],støperi_street).
composite_road(støttumveien,[],støttum_street).
composite_road(stålfjæra,[],stålfjæra).
composite_road(stålverkskroken,[],stålverkskroken).
composite_road(stålverksveien,[],stålverks_street).
composite_road(stårputtveien,[],stårputt_street).
composite_road(suhms,[street],suhms_street).
composite_road(suhms,[street],suhms_street).
composite_road(sukkertoppveien,[],sukkertopp_street).
composite_road(sundveien,[],sund_street).
composite_road(sunnmørgata,[],sunnmør_street).
composite_road(surstoffveien,[],surstoff_street).
composite_road(svalbardveien,[],svalbard_street).
composite_road(svaleveien,[],svale_street).
composite_road(svaneveien,[],svane_street).
composite_road(svartdalsveien,[],svartdals_street).
composite_road(svartdalsveien,[],svartdals_street).
composite_road(svarttrostveien,[],svarttrost_street).
composite_road(sveavegen,[],svea_street).
composite_road(sveiserveien,[],s_streetser_street).
composite_road(sveiva,[],s_streetva).
composite_road(sven,[bruns,street],sven_bruns_street).
composite_road(sven,[oftedals,street],sven_oftedals_street).
composite_road(svensenga,[],svensenga).
composite_road(svenskerudveien,[],svenskerud_street).
composite_road(svenskestien,[],svenskestien).
composite_road(svenstuveien,[],svenstu_street).
composite_road(sverdrups,[street],sverdrups_street).
composite_road(sveriges,[street],sveriges_street).
composite_road(sverre,[iversens,street],sverre_iversens_street).
composite_road(sverres,[street],sverres_street).
composite_road(svingen,[],svingen).
composite_road(svingen,[terrasse],svingen_terrasse).
composite_road(svoldergata,[],svolder_street).
composite_road(svovelstikka,[],svovelstikka).
composite_road(symreveien,[],symre_street).
composite_road(syrenveien,[],syren_street).
composite_road(sølve,[solfengs,street],sølve_solfengs_street).
composite_road(sømveien,[],søm_street).
composite_road(søndre,[street],søndre_street).
composite_road(søndre,[rød],søndre_rød).
composite_road(sørbråtveien,[],sørbråt_street).
composite_road(sørbyhaugen,[],sørbyhaugen).
composite_road(søren,[bulls,street],søren_bulls_street).
composite_road(søren,[jaabæks,street],søren_jaabæks_street).
composite_road(sørengkaia,[],sørengkaia).
composite_road(sørhellinga,[],sørhellinga).
composite_road(sørkedalen,[],sørkedalen).
composite_road(sørkedalsveien,[],sørkedals_street).
composite_road(sørkedalsveien,[],sørkedals_street).
composite_road(sørkedalsveien,[],sørkedals_street).
composite_road(sørligata,[],sørli_street).
composite_road(sørliveien,[],sørli_street).
composite_road(sørsletta,[],sørsletta).
composite_road(sørstien,[],sørstien).
composite_road(sørsvingen,[],sørsvingen).
composite_road(sørumgata,[],sørum_street).
composite_road(sørvangen,[],sørvangen).
composite_road(tallbergveien,[],tallberg_street).
composite_road(tamburveien,[],tambur_street).
composite_road(tangerudbakken,[],tangerudbakken).
composite_road(tangerudveien,[],tangerud_street).
composite_road(tante,[ulrikkes,street],tante_ulrikkes_street).
composite_road(teatergata,[],teater_street).
composite_road(teglverksgata,[],teglverks_street).
composite_road(teisenveien,[],teisen_street).
composite_road(telavåggata,[],telavåg_street).
composite_road(telemarksvingen,[],telemarksvingen).
composite_road(telesvingen,[],telesvingen).
composite_road(telthusbakken,[],telthusbakken).
composite_road(tennisveien,[],tennis_street).
composite_road(teppaveien,[],teppa_street).
composite_road(terneveien,[],terne_street).
composite_road(terningbekk,[],terningbekk).
composite_road(terrasseveien,[],terrasse_street).
composite_road(tevlingveien,[],tevling_street).
composite_road(th,[kittelsens,street],th_kittelsens_street).
composite_road(thaulows,[street],thaulows_street).
composite_road(theodor,[dahls,street],theodor_dahls_street).
composite_road(theodor,[løvstads,street],theodor_løvstads_street).
composite_road(thereses,[street],thereses_street).
composite_road(thomas,[heftyes,street],thomas_heftyes_street).
composite_road(thomles,[street],thomles_street).
composite_road(thor,[olsens,street],thor_olsens_street).
composite_road(thorleif,[haugs,street],thorleif_haugs_street).
composite_road(thorleifs,[alle],thorleifs_alle).
composite_road(thorn,[dønhaugs,street],thorn_dønhaugs_street).
composite_road(thorvald,[erichsens,street],thorvald_erichsens_street).
composite_road(thorvald,[meyers,street],thorvald_meyers_street).
composite_road(thorvald,[meyers,street],thorvald_meyers_street).
composite_road(thulstrups,[street],thulstrups_street).
composite_road(thunes,[street],thunes_street).
composite_road(thurmanns,[street],thurmanns_street).
composite_road(thygesons,[street],thygesons_street).
composite_road(tidemands,[street],tidemands_street).
composite_road(tingstuveien,[],tingstu_street).
composite_road(tiriltunga,[],tiriltunga).
composite_road(tirilveien,[],tiril_street).
composite_road(tistelholmen,[],tistelholmen).
composite_road(tittutgrenda,[],tittutgrenda).
composite_road(tittutveien,[],tittut_street).
composite_road(tiurveien,[],tiur_street).
composite_road(tjernfaret,[],tjernfaret).
composite_road(tjernlia,[],tjernlia).
composite_road(tjernveien,[],tjern_street).
composite_road(tjonerudbakken,[],tjonerudbakken).
composite_road(tjonerudveien,[],tjonerud_street).
composite_road(tjuvholmen,[alle],tjuvholmen_alle).
composite_road(toftdahls,[street],toftdahls_street).
composite_road(toftes,[street],toftes_street).
composite_road(toftes,[street],toftes_street).
composite_road(tokerudberget,[],tokerudberget).
composite_road(tokeruddalen,[],tokeruddalen).
composite_road(tollbugata,[],tollbu_street).
composite_road(tomm,[murstadbakken],tomm_murstadbakken).
composite_road(tomtekaia,[],tomtekaia).
composite_road(tonsenveien,[],tonsen_street).
composite_road(toppen,[],toppen).
composite_road(toppåsveien,[],toppås_street).
composite_road(tor,[jonssons,street],tor_jonssons_street).
composite_road(torbjørns,[street],torbjørns_street).
composite_road(tordenskiolds,[street],tordenskiolds_street).
composite_road(tore,[hals,mejdells,street],tore_hals_mejdells_street).
composite_road(tore,[hunds,street],tore_hunds_street).
composite_road(tores,[street],tores_street).
composite_road(torggata,[],torg_street).
composite_road(torggata,[],torg_street).
composite_road(torgny,[segerstedts,street],torgny_segerstedts_street).
composite_road(torjusbakken,[],torjusbakken).
composite_road(tormod,[knutsons,street],tormod_knutsons_street).
composite_road(tormods,[street],tormods_street).
composite_road(tors,[street],tors_street).
composite_road(torsborgveien,[],torsborg_street).
composite_road(torshovgata,[],torshov_street).
composite_road(torstølveien,[],torstøl_street).
composite_road(torvbakkgata,[],torvbakk_street).
composite_road(tostrup,[terrasse],tostrup_terrasse).
composite_road(tostrups,[street],tostrups_street).
composite_road(totengata,[],toten_street).
composite_road(traktorveien,[],traktor_street).
composite_road(traneveien,[],trane_street).
composite_road(trasoppterrassen,[],trasoppterrassen).
composite_road(trasoppveien,[],trasopp_street).
composite_road(traverveien,[],traver_street).
composite_road(trelastgata,[],trelast_street).
composite_road(treschows,[street],treschows_street).
composite_road(treskeveien,[],treske_street).
composite_road(trestegveien,[],tresteg_street).
composite_road(trettebakken,[],trettebakken).
composite_road(trimveien,[],trim_street).
composite_road(trolldalsveien,[],trolldals_street).
composite_road(trolldalsveien,[],trolldals_street).
composite_road(trollfaret,[],trollfaret).
composite_road(trollstien,[],trollstien).
composite_road(trollsvingen,[],trollsvingen).
composite_road(trollvannsveien,[],trollvanns_street).
composite_road(trollåsveien,[],trollås_street).
composite_road(tromsøgata,[],tromsø_street).
composite_road(trondheimsveien,[],trondheims_street).
composite_road(trondheimsveien,[],trondheims_street).
composite_road(trondheimsveien,[],trondheims_street).
composite_road(trondheimsveien,[],trondheims_street).
composite_road(trondheimsveien,[],trondheims_street).
composite_road(trondheimsveien,[],trondheims_street).
composite_road(trostefaret,[],trostefaret).
composite_road(trosterudstien,[],trosterudstien).
composite_road(trosterudveien,[],trosterud_street).
composite_road(trudvangveien,[],trudvang_street).
composite_road(trygve,[lies,plass],trygve_lies_plass).
composite_road(trygve,[nilsens,street],trygve_nilsens_street).
composite_road(trygve,[ryens,street],trygve_ryens_street).
composite_road(trygve,[strømbergs,street],trygve_strømbergs_street).
composite_road(tryms,[street],tryms_street).
composite_road(trysilgata,[],trysil_street).
composite_road(tryvannsveien,[],tryvanns_street).
composite_road(trøndergata,[],trønder_street).
composite_road(tråkka,[],tråkka).
composite_road(tuengen,[alle],tuengen_alle).
composite_road(tuengveien,[],tueng_street).
composite_road(tullins,[street],tullins_street).
composite_road(tunfaret,[],tunfaret).
composite_road(tungebråtveien,[],tungebråt_street).
composite_road(tunveien,[],tun_street).
composite_road(turbinveien,[],turbin_street).
composite_road(tverrbakken,[],tverrbakken).
composite_road(tverrvei,[2],tverr_street_2).
composite_road(tverrvei,[3],tverr_street_3).
composite_road(tverrvei,[4],tverr_street_4).
composite_road(tvetenveien,[],tveten_street).
composite_road(tvetenveien,[],tveten_street).
composite_road(tyribakken,[],tyribakken).
composite_road(tyrihansveien,[],tyrihans_street).
composite_road(tyristubbveien,[],tyristubb_street).
composite_road(tyslevkroken,[],tyslevkroken).
composite_road(tyslevveien,[],tyslev_street).
composite_road(tønsberggata,[],tønsberg_street).
composite_road(tørtbergveien,[],tørtberg_street).
composite_road(tøyenbekken,[],tøyenbekken).
composite_road(tøyengata,[],tøyen_street).
composite_road(tårnveien,[],tårn_street).
composite_road(tåsen,[alle],tåsen_alle).
composite_road(tåsen,[terrasse],tåsen_terrasse).
composite_road(tåsenveien,[],tåsen_street).
composite_road(tåsenveien,[],tåsen_street).
composite_road(uelands,[street],uelands_street).
composite_road(uelands,[street],uelands_street).
composite_road(uelands,[street],uelands_street).
composite_road(ugleveien,[],ugle_street).
composite_road(ulfstens,[street],ulfstens_street).
composite_road(ullagerveien,[],ullager_street).
composite_road(ullensakergata,[],ullensaker_street).
composite_road(ullern,[alle],ullern_alle).
composite_road(ullern,[gårds,street],ullern_gårds_street).
composite_road(ullernchausseen,[],ullernchausseen).
composite_road(ullernfaret,[],ullernfaret).
composite_road(ullernkammen,[],ullernkammen).
composite_road(ullernkollen,[],ullernkollen).
composite_road(ullernveien,[],ullern_street).
composite_road(ullevålsalleen,[],ullevålsalleen).
composite_road(ullevålsalleen,[],ullevålsalleen).
composite_road(ullevålseterveien,[],ullevålseter_street).
composite_road(ullevålsveien,[],ullevåls_street).
composite_road(ullveien,[],ull_street).
composite_road(ulsholtveien,[],ulsholt_street).
composite_road(ulsrudfaret,[],ulsrudfaret).
composite_road(ulsrudkollen,[],ulsrudkollen).
composite_road(ulsrudveien,[],ulsrud_street).
composite_road(ulvenveien,[],ulven_street).
composite_road(ulvenveien,[],ulven_street).
composite_road(ulvenveien,[],ulven_street).
composite_road(underhaugsveien,[],underhaugs_street).
composite_road(ungers,[street],ungers_street).
composite_road(universitetsgata,[],universitets_street).
composite_road(unnarennet,[],unnarennet).
composite_road(uranienborg,[terrasse],uranienborg_terrasse).
composite_road(uranienborgveien,[],uranienborg_street).
composite_road(urtegata,[],urte_street).
composite_road(urtestien,[],urtestien).
composite_road(ustvedts,[street],ustvedts_street).
composite_road(utfartsveien,[],utfarts_street).
composite_road(utmarkveien,[],utmark_street).
composite_road(utsikten,[],utsikten).
composite_road(utsynsveien,[],utsyns_street).
composite_road(vahls,[street],vahls_street).
composite_road(valborgs,[street],valborgs_street).
composite_road(valdresgata,[],valdres_street).
composite_road(valhallveien,[],valhall_street).
composite_road(valhallveien,[],valhall_street).
composite_road(valkyriegata,[],valkyrie_street).
composite_road(vallefaret,[],vallefaret).
composite_road(vallegata,[],valle_street).
composite_road(valmueveien,[],valmue_street).
composite_road(vangen,[],vangen).
composite_road(vardeheimveien,[],vardeheim_street).
composite_road(vardeveien,[],varde_street).
composite_road(vardøgata,[],vardø_street).
composite_road(vargveien,[],varg_street).
composite_road(vassfaret,[],vassfaret).
composite_road(veita,[],veita).
composite_road(veitvetstubben,[],veitvetstubben).
composite_road(veitvetsvingen,[],veitvetsvingen).
composite_road(veitvetveien,[],veitvet_street).
composite_road(vekslerveien,[],veksler_street).
composite_road(veksthusfløtten,[],veksthusfløtten).
composite_road(vekterveien,[],vekter_street).
composite_road(vendomveien,[],vendom_street).
composite_road(vennerbakken,[],vennerbakken).
composite_road(vennersborgveien,[],vennersborg_street).
composite_road(venåsveien,[],venås_street).
composite_road(verkseier,[furulunds,street],verkseier_furulunds_street).
composite_road(verksgata,[],verks_street).
composite_road(verkstedveien,[],verksted_street).
composite_road(veslefrikkveien,[],veslefrikk_street).
composite_road(veslekleiva,[],veslekleiva).
composite_road(veslekroken,[],veslekroken).
composite_road(vesleveien,[],vesle_street).
composite_road(vestbrynet,[],vestbrynet).
composite_road(vestbysvingen,[],vestbysvingen).
composite_road(vestbyveien,[],vestby_street).
composite_road(vestengsvingen,[],vestengsvingen).
composite_road(vestengveien,[],vesteng_street).
composite_road(vesteråsveien,[],vesterås_street).
composite_road(vestfoldgata,[],vestfold_street).
composite_road(vestgrensa,[],vestgrensa).
composite_road(vestheimgata,[],vestheim_street).
composite_road(vestlia,[],vestlia).
composite_road(vestlisvingen,[],vestlisvingen).
composite_road(vestliveien,[],vestli_street).
composite_road(vestre,[elvebakke],vestre_elvebakke).
composite_road(vestre,[haugen],vestre_haugen).
composite_road(vestre,[holmen,street],vestre_holmen_street).
composite_road(vestveien,[],vest_street).
composite_road(vetlandsfaret,[],vetlandsfaret).
composite_road(vetlandsveien,[],vetlands_street).
composite_road(vetlandsveien,[],vetlands_street).
composite_road(vettaliveien,[],vettali_street).
composite_road(via,[nova],via_nova).
composite_road(vibes,[street],vibes_street).
composite_road(victoria,[terrasse],victoria_terrasse).
composite_road(vidars,[street],vidars_street).
composite_road(vidjeveien,[],vidje_street).
composite_road(vidsynveien,[],vidsyn_street).
composite_road(viggo,[hansteens,street],viggo_hansteens_street).
composite_road(vikengata,[],viken_street).
composite_road(vikingveien,[],viking_street).
composite_road(vilberggrenda,[],vilberggrenda).
composite_road(vilbergveien,[],vilberg_street).
composite_road(villaveien,[],villa_street).
composite_road(vindernveien,[],vindern_street).
composite_road(vingolfveien,[],vingolf_street).
composite_road(vinkelveien,[],vinkel_street).
composite_road(vitaminveien,[],vitamin_street).
composite_road(vitaminveien,[],vitamin_street).
composite_road(vogts,[street],vogts_street).
composite_road(vogts,[street],vogts_street).
composite_road(voksenhagen,[],voksenhagen).
composite_road(voksenkollveien,[],voksenkoll_street).
composite_road(voksenliveien,[],voksenli_street).
composite_road(vollaveien,[],volla_street).
composite_road(vollebekkveien,[],vollebekk_street).
composite_road(volvat,[terrasse],volvat_terrasse).
composite_road(vossegata,[],vosse_street).
composite_road(vækerø,[terrasse],vækerø_terrasse).
composite_road(vækerøveien,[],vækerø_street).
composite_road(vækerøveien,[],vækerø_street).
composite_road(vækerøåsen,[],vækerøåsen).
composite_road(væringkleiva,[],væringkleiva).
composite_road(vøyensvingen,[],vøyensvingen).
composite_road(vågebyveien,[],vågeby_street).
composite_road(våghalsen,[],våghalsen).
composite_road(vålerenggata,[],vålereng_street).
composite_road(vålveien,[],vål_street).
composite_road(våronnveien,[],våronn_street).
composite_road(vårsvingen,[],vårsvingen).
composite_road(vårveien,[],vår_street).
composite_road(waldemar,[thranes,street],waldemar_thranes_street).
composite_road(waldemar,[thranes,street],waldemar_thranes_street).
composite_road(waldemar,[thranes,street],waldemar_thranes_street).
composite_road(waldemars,[hage],waldemars_hage).
composite_road(wedels,[street],wedels_street).
composite_road(welding,[olsens,street],welding_olsens_street).
composite_road(welhavens,[street],welhavens_street).
composite_road(wergelandsveien,[],wergelands_street).
composite_road(wergelandsveien,[],wergelands_street).
composite_road(wessels,[street],wessels_street).
composite_road(westye,[egebergs,street],westye_egebergs_street).
composite_road(wetlesens,[street],wetlesens_street).
composite_road(wildenveybakken,[],wildenveybakken).
composite_road(wilhelm,[færdens,street],wilhelm_færdens_street).
composite_road(wilhelm,[stenersens,street],wilhelm_stenersens_street).
composite_road(wilhelms,[street],wilhelms_street).
composite_road(wilses,[street],wilses_street).
composite_road(wilsters,[street],wilsters_street).
composite_road(wismargata,[],wismar_street).
composite_road(wolffs,[street],wolffs_street).
composite_road(ymers,[street],ymers_street).
composite_road(youngs,[street],youngs_street).
composite_road(youngstorget,[],youngstorget).
composite_road(zahlkasserer,[schafts,plass],zahlkasserer_schafts_plass).
composite_road(zetlitz,[street],zetlitz_street).
composite_road(zinoberveien,[],zinober_street).
composite_road(ødegårdsveien,[],ødegårds_street).
composite_road(øgårdsveien,[],øgårds_street).
composite_road(øivinds,[street],øivinds_street).
composite_road(økern,[torgvei],økern_torg_street).
composite_road(økernliveien,[],økernli_street).
composite_road(økernveien,[],økern_street).
composite_road(økernveien,[],økern_street).
composite_road(økernveien,[],økern_street).
composite_road(ørakerfaret,[],ørakerfaret).
composite_road(ørakerstien,[],ørakerstien).
composite_road(ørakerveien,[],øraker_street).
composite_road(øraveien,[],øra_street).
composite_road(østbakken,[],østbakken).
composite_road(østbyfaret,[],østbyfaret).
composite_road(østbyveien,[],østby_street).
composite_road(østdalsveien,[],østdals_street).
composite_road(østensjø,[terrasse],østensjø_terrasse).
composite_road(østensjøveien,[],østensjø_street).
composite_road(østensjøveien,[],østensjø_street).
composite_road(østensjøveien,[],østensjø_street).
composite_road(østerdalsgata,[],østerdals_street).
composite_road(østerli,[terrasse],østerli_terrasse).
composite_road(østerlisvingen,[],østerlisvingen).
composite_road(østerliveien,[],østerli_street).
composite_road(østfoldgata,[],østfold_street).
composite_road(østgaards,[street],østgaards_street).
composite_road(østhellinga,[],østhellinga).
composite_road(østhornveien,[],østhorn_street).
composite_road(østmarkveien,[],østmark_street).
composite_road(østre,[aker,street],østre_aker_street).
composite_road(østre,[aker,street],østre_aker_street).
composite_road(østre,[aker,street],østre_aker_street).
composite_road(østre,[elvebakke],østre_elvebakke).
composite_road(østre,[holmensvingen],østre_holmensvingen).
composite_road(østre,[street],østre_street).
composite_road(østreheimsveien,[],østreheims_street).
composite_road(østvangveien,[],østvang_street).
composite_road(østvollveien,[],østvoll_street).
composite_road(øverliveien,[],øverli_street).
composite_road(øvre,[street],øvre_street).
composite_road(øvre,[langås,street],øvre_langås_street).
composite_road(øvre,[ljanskoll,street],øvre_ljanskoll_street).
composite_road(øvre,[lunden],øvre_lunden).
composite_road(øvre,[myrhaugen],øvre_myrhaugen).
composite_road(øvre,[prinsdals,street],øvre_prinsdals_street).
composite_road(øvre,[skjoldvei],øvre_skjold_street).
composite_road(øvre,[skogvei],øvre_skog_street).
composite_road(øvre,[slottsgate],øvre_slotts_street).
composite_road(øvre,[smestadvei],øvre_smestad_street).
composite_road(øvre,[stabburvei],øvre_stabbur_street).
composite_road(øvre,[ullern,terrasse],øvre_ullern_terrasse).
composite_road(øvre,[vollgate],øvre_voll_street).
composite_road(øvrefoss,[],øvrefoss).
composite_road(øvreseterveien,[],øvreseter_street).
composite_road(øysteins,[plass],øysteins_plass).
composite_road(aagots,[street],aagots_street).
composite_road(aasmund,[vinjes,street],aasmund_vinjes_street).
composite_road(aasta,[hansteens,street],aasta_hansteens_street).
composite_road(åkebergveien,[],åkeberg_street).
composite_road(åkerøveien,[],åkerø_street).
composite_road(ålesundgata,[],ålesund_street).
composite_road(ålmoveien,[],ålmo_street).
composite_road(åmotveien,[],åmot_street).
composite_road(årrundkroken,[],årrundkroken).
composite_road(årrundveien,[],årrund_street).
composite_road(årvollia,[],årvollia).
composite_road(årvollveien,[],årvoll_street).
composite_road(årvollveien,[],årvoll_street).
composite_road(åsaveien,[],åsa_street).
composite_road(åsbakken,[],åsbakken).
composite_road(åsbråten,[],åsbråten).
composite_road(åsbråtstien,[],åsbråtstien).
composite_road(åsdalsveien,[],åsdals_street).
composite_road(åsengata,[],åsen_street).
composite_road(åsensvingen,[],åsensvingen).
composite_road(åsjordet,[],åsjordet).
composite_road(åslandhellinga,[],åslandhellinga).
composite_road(åslandkroken,[],åslandkroken).
composite_road(åslandveien,[],åsland_street).
composite_road(åsliveien,[],åsli_street).
composite_road(åsryggen,[],åsryggen).
composite_road(åssiden,[terrasse],åssiden_terrasse).
composite_road(åsstubben,[],åsstubben).
