package PrologConverter.regpas;

/**
 * Created on 19.11.14.
 * @author Espen
 */
public class TourItem {

    private String stopNumber;
    private String stopName;
    private int sequenceNumber;
    private int drivingTimeArrival;
    private int drivingTimeDeparture;


    public TourItem(String stopNumber, String stopName, int sequenceNumber, int drivingTimeArrival, int drivingTimeDeparture) {
        this.stopNumber = stopNumber;
        this.stopName = stopName;
        this.sequenceNumber = sequenceNumber;
        this.drivingTimeArrival = drivingTimeArrival;
        this.drivingTimeDeparture = drivingTimeDeparture;
    }


    public String getStopNumber() {
        return stopNumber;
    }


    public String getStopName() {
        return stopName;
    }


    public int getSequenceNumber() {
        return sequenceNumber;
    }


    public int getDrivingTimeArrival() {
        return drivingTimeArrival;
    }


    public int getDrivingTimeDeparture() {
        return drivingTimeDeparture;
    }


    @Override
    public boolean equals(Object object) {

        if(!(object instanceof TourItem))
            return false;

        TourItem tourItem = (TourItem) object;

        return tourItem.getDrivingTimeArrival() == drivingTimeArrival &&
                tourItem.getDrivingTimeDeparture() == drivingTimeDeparture &&
                tourItem.getStopName().equals(stopName) &&
                tourItem.getStopNumber().equals(stopNumber);
    }

    @Override
    public int hashCode() {
        return this.drivingTimeArrival + this.getDrivingTimeDeparture() + (13 * stopName.hashCode()) + (37 * stopNumber.hashCode());
    }
}
