package RegToppParser.models.regtopp;

import RegToppParser.control.FileTaskDelegator;
import RegToppParser.interfaces.RegToppFileParser;
import RegToppParser.models.Field;
import RegToppParser.models.FileType;
import RegToppParser.models.Version;

import java.io.File;

/**
 * Created on 15.11.14.
 * @author Espen Jacobsson
 */
public class SON extends RegToppObject implements RegToppFileParser {

    
    public SON(Version version) {
        super(version, Field.getFieldsForFileTypeAndVersion(FileType.SON, version));
        FileTaskDelegator.getInstance().registerFileParser(this, FileType.SON);
        
    }
    
    
    public boolean parse(File file) {
        return super.parseFile(file);
    }
}
